<?php
/**
 * Joomla! component creativeimagesliderpro
 *
 * @version $Id: default.php 2012-04-05 14:30:25 svn $
 * @author Creative-Solutions.net
 * @package Creative Image Slider
 * @subpackage com_creativeimagesliderpro
 * @license GNU/GPL v2.0
 *
 */

defined('_JEXEC') or die('Restricted access');

// Import library dependencies
jimport('joomla.plugin.plugin');
jimport('joomla.event.plugin');

class plgSystemCreativeimagesliderpro extends JPlugin {
    function __construct( &$subject ) {
      parent::__construct( $subject );
      // load plugin parameters and language file
      $this->_plugin = JPluginHelper::getPlugin( 'system', 'creativeimagesliderpro' );
      $this->_params = json_decode( $this->_plugin->params );
      JPlugin::loadLanguage('plg_system_creativeimagesliderpro', JPATH_ADMINISTRATOR);
    }
    
    function cispro_make_slider($m) {
    	$id_slider = (int) $m[2];
    	
    	//include helper class
    	require_once JPATH_SITE.'/components/com_creativeimagesliderpro/helpers/helper.php';
    	
    	$cispro_class = new CreativeimagesliderproHelper;
    	$cispro_class->slider_id = $id_slider;
    	$cispro_class->type = 'plugin';
    	$cispro_class->class_suffix = 'cispro_plg';
    	$cispro_class->module_id = $this->plg_order;
    	$this->plg_order ++;
    	return  $cispro_class->render_html();
    }

     function cispro_render_styles_scripts() {
         $document = JFactory::getDocument();
    	$content = JResponse::getBody();
    	
    	//check if the scripts did not included
    	if (strpos($content,'components/com_creativeimagesliderpro/assets/css/main.css') !== false) {
    		return $content;
    	}
    	
    	$version = '2.0.0';
    	
    	$cssFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/css/main.css?version='.$version;
    	$scripts = '<link rel="stylesheet" href="'.$cssFile.'" type="text/css" />'."\n";
    	
    	$cssFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/css/creative_buttons.css';
    	$scripts .= '<link rel="stylesheet" href="'.$cssFile.'" type="text/css" />'."\n";
    	
    	$cssFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/css/creativecss-ui.css';
    	$scripts .= '<link rel="stylesheet" href="'.$cssFile.'" type="text/css" />'."\n";
    	
    	$jsFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/js/creativelib.js';
    	$scripts .= '<script src="'.$jsFile.'" type="text/javascript"></script>'."\n";
    	
    	$jsFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/js/creativelib-ui.js';
    	$scripts .= '<script src="'.$jsFile.'" type="text/javascript"></script>'."\n";
    	
    	$jsFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/js/mousewheel.js';
    	$scripts .= '<script src="'.$jsFile.'" type="text/javascript"></script>'."\n";
    	
    	$jsFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/js/creativeimagesliderpro.js?version='.$version;
    	$scripts .= '<script src="'.$jsFile.'" type="text/javascript"></script>'."\n";
    	
    	$content = str_replace('</head>', $scripts . '</head>', $content);
    	return $content;
    }
    
    function onAfterRender() {
      $mainframe = JFactory::getApplication();
      if($mainframe->isAdmin())
        return;

      $plugin = JPluginHelper::getPlugin('system', 'creativeimagesliderpro');
      $pluginParams = json_decode( $plugin->params );

      $content = JResponse::getBody();
      
      //add scripts
      if(preg_match('/(\[creativeimagesliderpro id="([0-9]+)"\])/s',$content))
      	$content = $this->cispro_render_styles_scripts();
      else
      	return;
      
      $this->plg_order = 10000;
      //plugin 
      $c = preg_replace_callback('/(\[creativeimagesliderpro id="([0-9]+)"\])/s',array($this, 'cispro_make_slider'),$content);
      
      JResponse::setBody($c);
    }

}