(function($) {
$(window).load(function() {
	
	//claculate proper width
	function cispro_calculate_width() {
		$('.cispro_images_holder').each(function() {
			var $wrapper = $(this);
			var total_w = 0;
			$wrapper.find('.cispro_row_item').each(function() {
				$(this).find('img').css('width','auto');
				var w = parseInt($(this).find('img').width());
				$(this).find('img').width(w);
				var m_r = isNaN(parseFloat($(this).css('margin-right'))) ? 0 : parseFloat($(this).css('margin-right'));
				var m_l = isNaN(parseFloat($(this).css('margin-left'))) ? 0 : parseFloat($(this).css('margin-left'));
				total_w += w + m_r*1 + m_l*1;
			});
			total_w = total_w + 1*1;
			$wrapper.width(total_w);
		});
	};
	
	setTimeout(function() {
		cispro_calculate_width();
	},400);	

	//resize
	$(window).resize(function() {
	  cispro_calculate_width();
	});
	
	$(".cispro_row_item img").each(function() {
		var $cispro_overlay = $(this).next('.cispro_row_item_overlay');
		if($cispro_overlay.attr('cispro_animation') == 'enabled')
			return;
		$cispro_overlay.css({'visibility' : 'hidden','display' : 'block'});
		var h = $cispro_overlay.height();
		$cispro_overlay.css({'visibility' : 'visible','display' : 'block','height' : '0'}).attr('h',h);
		$cispro_overlay.attr('cispro_animation','enabled');
	});
	
	$(".cispro_row_item img").each(function() {
		if($(this).attr('cispro_loaded') == 'loaded')
			return;
		cispro_make_pr($(this));
	});
	
	function cispro_make_pr($el) {
		if($el.attr('cispro_loaded') == 'loaded')
			return;
		var item_width = $el.width();
		$el.parents('.cispro_row_item').find('.cispro_row_item_loader').animate({
			width: item_width
		},400,'swing',function() {
			$el.parents('.cispro_row_item').find('.cispro_row_item_loader').fadeOut(200,function() {
				$el.parents('.cispro_row_item_inner').hide().removeClass('cispro_row_hidden_element').fadeIn(200);
			});
		});
	};
	
});

$(document).ready(function() {
	//creative popup///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	/*
	//add popup html
	*/
	function cispro_add_creative_popup_html() {
		var cispro_base = $(".cispro_main_wrapper").attr("cispro_base");
		var popup_loader_loading_class = 'cispro_popup_wrapper_loader';
		var loader_popup_html = '<div class="cispro_popup_wrapper '+ popup_loader_loading_class +'" cispro_popup_autoplay="2"><div class="cispro_popup_autoplay_bar_holder"><div class="cispro_popup_autoplay_bar_wrapper"><div class="cispro_popup_autoplay_bar"></div></div></div><div class="cispro_popup_item_holder"><img src="" class="cispro_popup_left_arrow" /><img src="" class="cispro_popup_right_arrow" /><div class="cispro_popup_item_order_info"></div><img src="' + cispro_base + '/components/com_creativeimagesliderpro/assets/images/play.png" class="cispro_popup_autoplay_play" /><img src="' + cispro_base + '/components/com_creativeimagesliderpro/assets/images/pause.png" class="cispro_popup_autoplay_pause cispro_popup_topright_icon_hidden"/><img src="' + cispro_base + '/components/com_creativeimagesliderpro/assets/images/close.png" class="cispro_popup_close" /></div><div class="cispro_popup_bottom_holder"></div></div>';
		$('body').append(loader_popup_html);
	};
	cispro_add_creative_popup_html();

	/*
	//add overlay html
	*/
	function cispro_add_creative_overlay_html() {
		var overlay_html = '<div class="cispro_main_overlay"></div>';
		$('body').append(overlay_html);
	};
	cispro_add_creative_overlay_html();

	/*
	//popup event function
	*/
	$(".cispro_main_wrapper").each(function() {
		$(this).find(".cispro_row_item_overlay").each(function() {
			var $this = $(this);
			var cispro_popup_event = parseInt($this.attr("cispro_popup_event"));

			if(cispro_popup_event == 0) {//open popup onclick of button
				$this.find('.creative_btn').click(function(e) {
					e.preventDefault();

					//show overlay
					cispro_show_creative_overlay();

					//show popup
					var $loader = $(this).parents('.cispro_row_item').find('.cispro_row_item_inner');
					cispro_animate_creative_popup($loader);
				});
			}
			else if(cispro_popup_event == 1) {// open popup on click of overlay + button
				// set cursos pointer css to overlay
				$this.addClass('cispro_cursor_pointer');
				// click functon
				$this.click(function(e) {
					//show overlay
					cispro_show_creative_overlay();

					//show popup
					var $loader = $(this).parents('.cispro_row_item').find('.cispro_row_item_inner');
					cispro_animate_creative_popup($loader);
				});
			}
			else if(cispro_popup_event == 2) { // open link
				var cispro_click_target = parseInt($this.attr("cispro_click_target"));
				var cispro_click_url = $this.attr("cispro_click_url");
				var cispro_button_visible = parseInt($this.attr("cispro_button_visible"));

				if(cispro_button_visible == 0) {// if button not visible, onclick ov overlay open link
					// set cursos pointer css to overlay
					$this.addClass('cispro_cursor_pointer');

					$this.click(function(e) {
						if(cispro_click_target == 1)
							window.open(cispro_click_url);
						else
							window.location.href = cispro_click_url;

					});
				}
			}
		});
	});

	/*
	//make items ordering
	*/
	function cispro_make_creative_items_orders() {
		$('.cispro_main_wrapper').each(function(){
			var curr_order = 0;
			$(this).find('.cispro_row_item').each(function() {
				$(this).attr("cispro_item_order",curr_order)
				curr_order ++;
			})
		})
	};
	cispro_make_creative_items_orders();

	/*
	//overlay functions
	*/
	function cispro_show_creative_overlay() {
		var windowWidth = $(document).width(); //retrieve current window width
		var windowHeight = $(document).height(); //retrieve current window height
		$('.cispro_main_overlay').css({'width':windowWidth,'height':windowHeight}).stop().fadeTo(400,0.8);
	};
	function cispro_resize_creative_overlay() {
		var windowWidth = $(document).width(); //retrieve current window width
		var windowHeight = $(document).height(); //retrieve current window height
		$('.cispro_main_overlay').css({'width':windowWidth,'height':windowHeight});
	};
	function cispro_hide_creative_overlay() {
		$('.cispro_main_overlay').stop().fadeOut(400,function() {
			$(this).css({'width':'100%','height':'100%'});
			//reset popup html

			$('.cispro_popup_item').remove();
			$('.cispro_popup_bottom_holder').removeAttr("style").removeAttr("h").html('');
			$('.cispro_popup_wrapper').removeClass('cispro_popup_in_progress');
		});
	};

	/*
	//function to create popup paths
	*/
	var cispro_popup_paths = new Array();
	$('.cispro_main_wrapper').each(function() {
		var cispro_slider_id = $(this).attr("cispro_slider_id");
		cispro_popup_paths[cispro_slider_id] = new Array();
		var item_order = 0;
		$(this).find('.cispro_row_item').each(function() {
			$this = $(this);
			var item_popup_path = $(this).attr("cispro_popup_link");

			if(item_popup_path != '') {
				item_order ++;
				cispro_popup_paths[cispro_slider_id][item_order] = item_popup_path;
				$this.attr("cispro_popup_order", item_order).addClass('cispro_has_popup');
			}
		});
		$(this).attr("cispro_popup_items_count",item_order);
	});


	/*
	//function to animate popup
	*/
	function cispro_animate_creative_popup($loader) {
		//get popup image
		var slider_id = $loader.parents('.cispro_main_wrapper').attr("cispro_slider_id");
		var slider_id_unique = $loader.parents('.cispro_main_wrapper').attr("roll");
		var item_order = $loader.parents('.cispro_row_item').attr("cispro_popup_order");
		var item_id = $loader.parents('.cispro_row_item').attr("item_id");
		var cispro_popup_link = cispro_popup_paths[slider_id][item_order];

		//get data
		var slider_data =$loader.parents('.cispro_main_wrapper').find('.cispro_popup_data').html();
		var slider_data_array = slider_data.split(',');
		var cispro_popup_use_back_img = parseInt(slider_data_array[2]);


		var $cispro_popup = $('.cispro_popup_wrapper');
		$cispro_popup.addClass('cispro_popup_in_progress');
		$cispro_popup.attr("slider_id", slider_id_unique);
		$cispro_popup.addClass('cispro_vissible');

		//show or hide overlay bg image
		if(cispro_popup_use_back_img == 0)
			$('.cispro_main_overlay').addClass('cispro_main_overlay_without_bg');
		else
			$('.cispro_main_overlay').removeClass('cispro_main_overlay_without_bg');


		var popup_loader_animate_timeout1 = 10;
		setTimeout(function() {
			//get loader sizes, coordinates
			var w = parseInt($loader.css('width'));	
			var h = parseInt($loader.css('height'));

			//get body borders
			var body_border_top = parseInt($('body').css('border-top-width'));
			var body_border_left = parseInt($('body').css('border-left-width'));

			//get offsets
			var offset_top = $loader.offset().top;
			var offset_left = $loader.offset().left;

			var offset_top_final = offset_top;
			var offset_left_final = offset_left;

			//scroll positions
			var vScrollPosition = $(document).scrollTop(); //retrieve the document scroll ToP position
			var hScrollPosition = $(document).scrollLeft(); //retrieve the document scroll Left position

			//show popup
			
			$cispro_popup
			.hide()
			.attr("start_data", w + ',' + h + ',' + offset_top_final + ',' + offset_left_final + ',' + vScrollPosition + ',' + hScrollPosition)
			.css({
				'width': w,
				'height': h,
				'top': offset_top,
				'left': offset_left_final
			})
			.fadeIn(400, function() {
				cispro_show_image(item_id);
			});
		},popup_loader_animate_timeout1);
	};

	//function to back the popup to start position
	function cispro_reset_creative_popup() {
		var $cispro_popup = $('.cispro_popup_wrapper');
		var slider_id = $cispro_popup.attr("slider_id");

		//hide arrows 
		cispro_popup_hide_arrows();
		//hide image order data
		cispro_popup_hide_item_order();
		//hide popup autoplay bar
		cispro_popup_hide_autoplay_bar();
		//hide tpright arrows
		cispro_popup_hide_topright_icons();

		//check if popup is ready
		if($cispro_popup.hasClass('cispro_popup_in_progress'))
			return;

		//set popup ready!
		$cispro_popup.addClass('cispro_popup_in_progress');

		var $cispro_popup_item = $cispro_popup.find('.cispro_popup_item');
		var $cispro_popup_bottom = $cispro_popup.find('.cispro_popup_bottom_holder');

		$cispro_popup.removeClass("cispro_vissible");

		var start_data = $cispro_popup.attr("start_data");
		var start_data_array = start_data.split(",");
		var bottom_h = parseInt($cispro_popup.find('.cispro_popup_bottom_holder').attr("h"));

		var cispro_popup_animate_back_timeout = 0;
		setTimeout(function() {

			//hide item
			$cispro_popup_item.fadeOut(400);

			$('.cispro_main_overlay').stop().fadeTo(400,0.8);

			//animate main popup
			$cispro_popup.stop().animate({
				'height':'-=' + bottom_h
			},
			{
				duration: 400, 
				queue: false, 
				easing: 'swing',
				complete: function() {
					setTimeout(function() {
						$("body").stop().animate({
							scrollTop: start_data_array[4]
						},400);

						$cispro_popup
						.removeClass("cispro_popup_wrapper_loader_shaddow")
						.animate({
							'width': start_data_array[0],
							'height': start_data_array[1],
							'top': start_data_array[2],
							'left': start_data_array[3]
						},400,'swing', function() {
							$cispro_popup.fadeOut(400);
							cispro_hide_creative_overlay();

							// trigger mouseleave, to continue auto-play(if exists).
							$('.cispro_wrapper_' + slider_id).trigger("mouseleave");
						});
					},100);
				}
			});

			//animate popup bottom
			$cispro_popup_bottom.stop().animate({
				'height':'0'
			},
			{
				duration: 400, 
				queue: false, 
				easing: 'swing', 
				complete: function() {
					$(this).hide();
				}
			});
		},cispro_popup_animate_back_timeout);
		
	};


	function cispro_show_image(item_id) {
		$loader = $("#cispro_item_" + item_id).find('.cispro_row_item_inner');

		var $cispro_popup = $('.cispro_popup_wrapper');
		$cispro_popup.addClass('cispro_vissible');
		$cispro_popup.attr("item_id", item_id);

		//get popup image
		var slider_id = $loader.parents('.cispro_main_wrapper').attr("cispro_slider_id");
		var item_order = $loader.parents('.cispro_row_item').attr("cispro_popup_order");
		var items_count = $loader.parents('.cispro_main_wrapper').attr("cispro_popup_items_count");
		var cispro_popup_link = cispro_popup_paths[slider_id][item_order];

		//get data
		var slider_data =$loader.parents('.cispro_main_wrapper').find('.cispro_popup_data').html();
		var slider_data_array = slider_data.split(',');
		var cispro_popup_max_size = parseInt(slider_data_array[0]);
		var cispro_popup_item_min_width = parseInt(slider_data_array[1]);

		// set item order info
		var cispro_popup_item_order_text = item_order + ' of ' + items_count;
		$('.cispro_popup_item_order_info').html(cispro_popup_item_order_text)

		var cispro_title = $("#cispro_item_" + item_id).find('.cispro_row_item_overlay_txt').html();
		var cispro_desc = $("#cispro_item_" + item_id).find('.cispro_popup_caption').html();
		
		// if url is empty, reset popup
		if(cispro_popup_link == '' || cispro_popup_link == undefined) {
			$cispro_popup.removeClass('cispro_popup_in_progress')
			cispro_reset_creative_popup();
		};

		//load image
		var $popup_img = $("<img />", { src:cispro_popup_link,class:'cispro_popup_item'});
		$popup_img
		.error(function() { 
			alert("Error loading image");
			console.log("Error loading image. Url: " + cispro_popup_link);
			$cispro_popup.removeClass('cispro_popup_in_progress')
			cispro_reset_creative_popup();
		})
		.load(function() {

			$popup_img.addClass('cispro_hidden').appendTo("body");

			var img_width = parseInt($popup_img.width());
			var img_height = parseInt($popup_img.height());
			var img_ratio = img_height / img_width;
			var img_width_final = img_width;
			var img_height_final = img_height;

			$popup_img.attr("w",img_width);
			$popup_img.attr("h",img_height);

			var $popup_img_final = $popup_img;
			$popup_img.remove();
			$popup_img_final.removeClass('cispro_hidden');

			$cispro_popup.append($popup_img_final);

			var windowWidth = parseInt($(window).width()); //retrieve current window width
			var windowHeight = parseInt($(window).height()); //retrieve current window height
			var vScrollPosition = parseInt($(document).scrollTop()); //retrieve the document scroll ToP position
			var hScrollPosition = parseInt($(document).scrollLeft()); //retrieve the document scroll Left position

			// set limits
			var cispro_max_percent_w = cispro_popup_max_size;
			var cispro_max_percent_h = cispro_popup_max_size;

			// calculate max sizes
			var max_allowed_w = parseInt(windowWidth * cispro_max_percent_w / 100);
			var max_allowed_h = parseInt(windowHeight * cispro_max_percent_h / 100);

			//if image height greater than max allowed size, make corrections!
			if(img_height > max_allowed_h) {
				var img_height_check = max_allowed_h;
				var img_width_check = max_allowed_h / img_ratio;

				//check if calculated with in allowed range
				if(img_width_check > max_allowed_w) {
					img_width_check = max_allowed_w;
					img_height_check = max_allowed_w * img_ratio;
				}

				//set values
				img_width_final = img_width_check;
				img_height_final = img_height_check;

			}	
			else if(img_width > max_allowed_w) {
				var img_width_check = max_allowed_w;
				var img_height_check = max_allowed_w * img_ratio;

				//check if calculated with in allowed range
				if(img_height_check > max_allowed_h) {
					img_height_check = max_allowed_h;
					img_width_check = max_allowed_h / img_ratio;
				}

				//set values
				img_width_final = img_width_check;
				img_height_final = img_height_check;
			}

			// get autoplay bar
			var $autoplay_bar_holder = $('.cispro_popup_autoplay_bar_holder');
			var $autoplay_bar_holder = $('.cispro_popup_autoplay_bar');
			var autolplay_bar_h = parseInt($autoplay_bar_holder.attr("h"));

			//get bottom
			var bottom_htm = '<div class="cispro_popup_bottom_inner_wrapper cispro_hidden"><div class="cispro_popup_bottom_inner">';
			bottom_htm += '<div class="cispro_popup_bottom_title">' + cispro_title + '</div>';
			if(cispro_desc != '')
				bottom_htm += '<div class="cispro_popup_bottom_desc">' + cispro_desc + '</div>';
			bottom_htm += '<div class="cispro_popup_bottom_line"></div></div></div>';

			//get bottom height
			var bottom_htm_dummy = bottom_htm;
			$cispro_popup.append(bottom_htm_dummy);
			$(".cispro_popup_bottom_inner_wrapper").width(img_width_final);
			var bottom_height = $(".cispro_popup_bottom_inner_wrapper").height();

			// check if total width in allowed range
			if(img_height_final + 1*bottom_height > max_allowed_h) {
				img_height_final = max_allowed_h - bottom_height;
				img_height_final = img_height_final > img_height ? img_height : img_height_final;
				img_width_final = img_height_final / img_ratio;

				//check min size
				var cispro_min_width = cispro_popup_item_min_width;
				if(img_width_final < cispro_min_width) {
					img_width_final = cispro_min_width;
					img_height_final = img_width_final * img_ratio;
				}
			}

			//calculate buttom height again
			$cispro_popup.append(bottom_htm_dummy);
			$(".cispro_popup_bottom_inner_wrapper").width(img_width_final);
			bottom_height = $(".cispro_popup_bottom_inner_wrapper").height();

			$(".cispro_popup_bottom_inner_wrapper").remove();
			$cispro_popup.find('.cispro_popup_bottom_holder').attr("h",bottom_height).hide().html(bottom_htm);
			$(".cispro_popup_bottom_inner_wrapper").removeClass('cispro_hidden');

			//get final offsets
			var popup_top_final = vScrollPosition + 0.3*(windowHeight - img_height_final - bottom_height);
			//if we have negative top offset, turn off scrolling behaviour, set fixed top position
			var cispro_scroll_disable = false;
			if(popup_top_final < vScrollPosition) {
				popup_top_final = vScrollPosition + 12*1;
				if(!$cispro_popup.hasClass('cispro_popup_disable_scrolling_behaviour'))
					$cispro_popup.addClass('cispro_popup_disable_scrolling_behaviour')
				cispro_scroll_disable = true;
			}
			else {
				$cispro_popup.removeClass('cispro_popup_disable_scrolling_behaviour')
			}

			var popup_left_final = hScrollPosition + 0.5 * (windowWidth - img_width_final);
			//if we have negative top offset, turn off scrolling behaviour, set fixed top position
			if(popup_left_final < hScrollPosition) {
				popup_left_final = hScrollPosition + 12*1;
				if(!$cispro_popup.hasClass('cispro_popup_disable_scrolling_behaviour'))
					$cispro_popup.addClass('cispro_popup_disable_scrolling_behaviour')
			}
			else if(!cispro_scroll_disable){
				$cispro_popup.removeClass('cispro_popup_disable_scrolling_behaviour')
			}	

			//place image
			$popup_img_final.css({
				'width': img_width_final,
				'height': img_height_final,
				'display': 'none'
			});

			$cispro_popup.find('.cispro_popup_item_holder').append($popup_img_final);

			//animate popup
			$cispro_popup.stop().animate({
				'width': img_width_final,
				'height': img_height_final,
				'top' : popup_top_final,
				'left' : popup_left_final
			},400, 'easeOutBack', function() {
				//show image
				$popup_img_final.stop().fadeIn(400,function() {

					$('.cispro_main_overlay').stop().fadeTo(400,0.96);
					$cispro_popup.addClass('cispro_popup_wrapper_loader_shaddow');

					//$cispro_popup.find('.cispro_popup_bottom_holder').css('visibility','visible');
					//prepare bottom
					$cispro_popup.stop().animate({
						'height': '+=' + bottom_height
					},400,'swing',function() {

						//set popup ready!
						$cispro_popup.removeClass('cispro_popup_in_progress');

						//prepare arrows
						cispro_prepare_popup_arrows();

						//prepare  order info
						cispro_popup_prepare_item_order_info();

						//show autoplay bar wrapper
						cispro_popup_show_autoplay_bar();

						// prepare top-right icons
						cispro_popup_prepare_topright_icons();

						// prepare popup autoplay
						cispro_popup_prepare_autoplay();
					});

					//animate bottom inner
					$cispro_popup.find('.cispro_popup_bottom_holder').stop().fadeIn(400);

				});

			});

		});
	};

	function cispro_resize_image() {
		var $cispro_popup = $('.cispro_popup_wrapper');

		//check if popup is ready
		if($cispro_popup.hasClass('cispro_popup_in_progress'))
			return;

		//return, if popup is not visible
		if(!$cispro_popup.hasClass('cispro_vissible'))
			return;

		// get item id
		var item_id = $cispro_popup.attr("item_id");
		$loader = $("#cispro_item_" + item_id).find('.cispro_row_item_inner');

		//get data
		var slider_data =$loader.parents('.cispro_main_wrapper').find('.cispro_popup_data').html();
		var slider_data_array = slider_data.split(',');
		var cispro_popup_max_size = parseInt(slider_data_array[0]);
		var cispro_popup_item_min_width = parseInt(slider_data_array[1]);

		//get image
		var $popup_img = $('.cispro_popup_item');
		$popup_img.css({'width':'100%','height':'auto'})

		// get sizes
		var img_width = parseInt($popup_img.attr("w"));
		var img_height = parseInt($popup_img.attr("h"));
		var img_ratio = img_height / img_width;
		var img_width_final = img_width;
		var img_height_final = img_height;

		var windowWidth = parseInt($(window).width()); //retrieve current window width
		var windowHeight = parseInt($(window).height()); //retrieve current window height
		var vScrollPosition = parseInt($(document).scrollTop()); //retrieve the document scroll ToP position
		var hScrollPosition = parseInt($(document).scrollLeft()); //retrieve the document scroll Left position

		// set limits
		var cispro_max_percent_w = cispro_popup_max_size;
		var cispro_max_percent_h = cispro_popup_max_size;

		// calculate max sizes
		var max_allowed_w = parseInt(windowWidth * cispro_max_percent_w / 100);
		var max_allowed_h = parseInt(windowHeight * cispro_max_percent_h / 100);

		//if image height greater than max allowed size, make corrections!
		if(img_height > max_allowed_h) {
			var img_height_check = max_allowed_h;
			var img_width_check = max_allowed_h / img_ratio;

			//check if calculated with in allowed range
			if(img_width_check > max_allowed_w) {
				img_width_check = max_allowed_w;
				img_height_check = max_allowed_w * img_ratio;
			}

			//set values
			img_width_final = img_width_check;
			img_height_final = img_height_check;

		}	
		else if(img_width > max_allowed_w) {
			var img_width_check = max_allowed_w;
			var img_height_check = max_allowed_w * img_ratio;

			//check if calculated with in allowed range
			if(img_height_check > max_allowed_h) {
				img_height_check = max_allowed_h;
				img_width_check = max_allowed_h / img_ratio;
			}

			//set values
			img_width_final = img_width_check;
			img_height_final = img_height_check;
		}

		var bottom_height = parseInt($(".cispro_popup_bottom_holder").attr("h"));

		// check if total width in allowed range
		if(img_height_final + 1*bottom_height > max_allowed_h) {
			img_height_final = max_allowed_h - bottom_height;
			img_height_final = img_height_final > img_height ? img_height : img_height_final;
			img_width_final = img_height_final / img_ratio;

			//check min size
			var cispro_min_width = cispro_popup_item_min_width;
			if(img_width_final < cispro_min_width) {
				img_width_final = cispro_min_width;
				img_height_final = img_width_final * img_ratio;
			}
		}

		// calculate buttom height again
		var  bottom_htm_dummy = $('.cispro_popup_bottom_inner_wrapper').html();
		bottom_htm_dummy = '<div class="cispro_popup_bottom_inner_wrapper_dummy cispro_hidden">' + bottom_htm_dummy + '</div>';

		$cispro_popup.append(bottom_htm_dummy);
		$(".cispro_popup_bottom_inner_wrapper_dummy").width(img_width_final);
		bottom_height = $(".cispro_popup_bottom_inner_wrapper_dummy").height();

		$(".cispro_popup_bottom_inner_wrapper_dummy").remove();
		$cispro_popup.find('.cispro_popup_bottom_holder').attr("h",bottom_height);

		//get final offsets
		var popup_top_final = vScrollPosition + 0.3*(windowHeight - img_height_final - bottom_height);
		//if we have negative top offset, turn off scrolling behaviour, set fixed top position
		var cispro_scroll_disable = false;
		if(popup_top_final < vScrollPosition) {
			popup_top_final = vScrollPosition + 12*1;
			if(!$cispro_popup.hasClass('cispro_popup_disable_scrolling_behaviour'))
				$cispro_popup.addClass('cispro_popup_disable_scrolling_behaviour')
			cispro_scroll_disable = true;
		}
		else {
			$cispro_popup.removeClass('cispro_popup_disable_scrolling_behaviour')
		}

		var popup_left_final = hScrollPosition + 0.5 * (windowWidth - img_width_final);
		//if we have negative top offset, turn off scrolling behaviour, set fixed top position
		if(popup_left_final < hScrollPosition) {
			popup_left_final = hScrollPosition + 12*1;
			if(!$cispro_popup.hasClass('cispro_popup_disable_scrolling_behaviour'))
				$cispro_popup.addClass('cispro_popup_disable_scrolling_behaviour')
		}
		else if(!cispro_scroll_disable){
			$cispro_popup.removeClass('cispro_popup_disable_scrolling_behaviour')
		};


		//animate popup
		var total_h = img_height_final + 1*bottom_height;
		$cispro_popup.stop().animate({
			'width': img_width_final,
			'height': total_h,
			'top' : popup_top_final,
			'left' : popup_left_final
		},400,'easeOutBack', function() {
			//resize arrows
			cispro_resize_popup_arrows();
		});

	};

	function cispro_move_image() {
		var $cispro_popup = $('.cispro_popup_wrapper');

		//check if popup is ready
		if($cispro_popup.hasClass('cispro_popup_in_progress'))
			return;

		//return, if popup is not visible
		if(!$cispro_popup.hasClass('cispro_vissible'))
			return;

		// return, if scrolling not enabled
		if($cispro_popup.hasClass('cispro_popup_disable_scrolling_behaviour'))
			return;

		var item_id = $cispro_popup.attr("item_id");

		var popup_width = $cispro_popup.width();
		var popup_height = $cispro_popup.height();

		var windowWidth = $(window).width(); //retrieve current window width
		var windowHeight = $(window).height(); //retrieve current window height
		var vScrollPosition = $(document).scrollTop(); //retrieve the document scroll ToP position
		var hScrollPosition = $(document).scrollLeft(); //retrieve the document scroll Left position

		//get final offsets
		var popup_top_final = vScrollPosition + 0.3*(windowHeight - popup_height);
		var popup_left_final = (windowWidth - popup_width) / 2;

		//animate popup
		$cispro_popup.stop(false,false).animate({
			'top' : popup_top_final,
			'left' : popup_left_final
		},400, 'swing');

	};

	$(window).scroll(function() {
		cispro_move_image();
	});	

	$(window).resize(function() {
		cispro_resize_creative_overlay();
	    clearTimeout($.data(this, 'cisproResizeTimer'));
	    $.data(this, 'cisproResizeTimer', setTimeout(function() {
	        cispro_resize_image();
	    }, 200));
	});

	//keyup
	$(document).keyup(function (e) {
		var cispro_keycode = e.keyCode;
	    if (cispro_keycode == 37 || cispro_keycode == 39 || cispro_keycode == 27) {
	    	var $cispro_popup = $('.cispro_popup_wrapper');
	    	if($cispro_popup.hasClass('cispro_vissible')) {
	    		if(cispro_keycode == 27) // reset popup when typr ESC button
	    			cispro_reset_creative_popup();
	    		else if(cispro_keycode == 39) // show next when type right button
	    			cispro_popup_show_next_item();
	    		else if(cispro_keycode == 37) // show prev when type left button
	    			cispro_popup_show_prev_item();
	    	} 
	    }
	});

	$(".cispro_main_overlay").on('click', function() {
		cispro_reset_creative_popup();
	});

	//popup arrow navigation
	function cispro_prepare_popup_arrows() {
		var $cispro_popup = $('.cispro_popup_wrapper');
		var item_id = $cispro_popup.attr("item_id");

		// get slider arrows
		var $left_arrow = $("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_button_left');
		var $right_arrow = $("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_button_right');

		var $cispro_popup_left_arrow = $('.cispro_popup_left_arrow');
		var $cispro_popup_right_arrow = $('.cispro_popup_right_arrow');

		//get data
		var slider_data = $("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_popup_data').html();
		var slider_data_array = slider_data.split(',');
		var cispro_popup_arrow_min_height = parseInt(slider_data_array[5]);
		var cispro_popup_arrow_max_height = parseInt(slider_data_array[6]);
		var cispro_popup_showarrows = parseInt(slider_data_array[7]);
		var cispro_popup_arrow_passive_opacity = parseInt(slider_data_array[3]) / 100;
		var cispro_popup_arrow_left_offset = parseInt(slider_data_array[4]);

		//set arrow attributes
		var cispro_corner_offset = cispro_popup_arrow_left_offset;
		$cispro_popup_left_arrow.attr({"src":$left_arrow.attr("src"),'op':cispro_popup_arrow_passive_opacity,'corner_offset':cispro_corner_offset});
		$cispro_popup_right_arrow.attr({"src":$right_arrow.attr("src"),'op':cispro_popup_arrow_passive_opacity,'corner_offset':cispro_corner_offset});

		//calculate arrow height
		var cispro_slider_h = parseInt($("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_row_item_inner').height());
		var cispro_slider_arrow_h = parseInt($left_arrow.css("height"));
		var arrow_ratio = cispro_slider_arrow_h / cispro_slider_h;

		var arrow_max_h = parseInt($cispro_popup_left_arrow.height());
		var arrow_container_height = parseInt($('.cispro_popup_item_holder').height());

		arrow_max_h = cispro_popup_arrow_max_height;
		var arrow_min_h = cispro_popup_arrow_min_height;
		var arrow_h_claculated = arrow_container_height * 0.085;
		var arrow_h_final = arrow_h_claculated > arrow_max_h ? arrow_max_h : (arrow_h_claculated < arrow_min_h ? arrow_min_h : arrow_h_claculated);

		//get arrow position
		var arrow_top = 0.5 * (arrow_container_height - arrow_h_final);

		var arrow_op_pasive = cispro_popup_arrow_passive_opacity;

		// set arrows css
		$cispro_popup_left_arrow.css({
			'left': '-64px',
			'top': arrow_top,
			'height': arrow_h_final,
			'opacity': arrow_op_pasive
		});
		$cispro_popup_right_arrow.css({
			'left': 'auto',
			'right': '-64px',
			'top': arrow_top,
			'height': arrow_h_final,
			'opacity': arrow_op_pasive
		});


		var cispro_popup_show_arrows_ident = cispro_popup_showarrows;

		//delete previously declired hover event
		$cispro_popup.off('mouseenter.cispro_popup_hover_handler');
		$cispro_popup.off('mouseleave.cispro_popup_hover_handler');

		// arrow showing type
		if(cispro_popup_show_arrows_ident == 0) {//never show arrows
			// Do Nothing
		}
		else if(cispro_popup_show_arrows_ident == 1) {//show on hover
			// show arrows
			cispro_popup_show_arrows();

			// set hover functions
			$cispro_popup.on('mouseenter.cispro_popup_hover_handler', function() {
				cispro_popup_show_arrows();
			});
			$cispro_popup.on('mouseleave.cispro_popup_hover_handler', function() {
				cispro_popup_hide_arrows();
			});
			
		}
		else {
			cispro_popup_show_arrows();
		}

	};

	// resize popup arrows
	function cispro_resize_popup_arrows() {
		var $cispro_popup = $('.cispro_popup_wrapper');
		var item_id = $cispro_popup.attr("item_id");

		// get slider arrows
		var $left_arrow = $("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_button_left');
		var $right_arrow = $("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_button_right');

		var $cispro_popup_left_arrow = $('.cispro_popup_left_arrow');
		var $cispro_popup_right_arrow = $('.cispro_popup_right_arrow');

		//calculate arrow height
		var cispro_slider_h = parseInt($("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_row_item_inner').height());
		var cispro_slider_arrow_h = parseInt($left_arrow.css("height"));
		var arrow_ratio = cispro_slider_arrow_h / cispro_slider_h;

		var arrow_max_h = parseInt($cispro_popup_left_arrow.height());
		var arrow_container_height = parseInt($('.cispro_popup_item_holder').height());

		//get data
		var slider_data = $("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_popup_data').html();
		var slider_data_array = slider_data.split(',');
		var cispro_popup_arrow_min_height = parseInt(slider_data_array[5]);
		var cispro_popup_arrow_max_height = parseInt(slider_data_array[6]);
		var cispro_popup_arrow_passive_opacity = parseInt(slider_data_array[3]);

		arrow_max_h = cispro_popup_arrow_max_height;
		var arrow_min_h = cispro_popup_arrow_min_height;
		var arrow_h_claculated = arrow_container_height * 0.085;
		var arrow_h_final = arrow_h_claculated > arrow_max_h ? arrow_max_h : (arrow_h_claculated < arrow_min_h ? arrow_min_h : arrow_h_claculated);

		//get arrow position
		var arrow_top = 0.5 * (arrow_container_height - arrow_h_final);

		var arrow_op_pasive = cispro_popup_arrow_passive_opacity;

		// animate arrows
		$cispro_popup_left_arrow.stop().animate({
			'top': arrow_top,
			'height': arrow_h_final
		},400,'easeOutBack');
		$cispro_popup_right_arrow.stop().animate({
			'top': arrow_top,
			'height': arrow_h_final
		},400,'easeOutBack');

	};

	function cispro_popup_prepare_item_order_info() {
		var $cispro_popup = $('.cispro_popup_wrapper');

		var item_id = $cispro_popup.attr("item_id");

		//get data
		var slider_data = $("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_popup_data').html();
		var slider_data_array = slider_data.split(',');
		var cispro_popup_image_order_opacity = parseInt(slider_data_array[8]) / 100;
		var cispro_popup_show_orderdata = parseInt(slider_data_array[10]);

		var op_pasive = cispro_popup_image_order_opacity;
		$('.cispro_popup_item_order_info').attr("op",op_pasive);

		var cispro_popup_show_item_order_ident = cispro_popup_show_orderdata;

		//delete previously declired hover function
		$cispro_popup.off('mouseenter.cispro_popup_show_order_hover_handler');
		$cispro_popup.off('mouseleave.cispro_popup_show_order_hover_handler');

		// order info showing type
		if(cispro_popup_show_item_order_ident == 0) {//never show
			// Do Nothing
		}
		else if(cispro_popup_show_item_order_ident == 1) {//show on hover
			// show arrows
			cispro_popup_show_item_order();

			// set hover functions
			$cispro_popup.on('mouseenter.cispro_popup_show_order_hover_handler', function() {
				cispro_popup_show_item_order();
			});
			$cispro_popup.on('mouseleave.cispro_popup_show_order_hover_handler', function() {
				cispro_popup_hide_item_order();
			});
			
		}
		else { //always show
			cispro_popup_show_item_order();
		}

	};	

	function cispro_popup_prepare_topright_icons() {
		var $cispro_popup = $('.cispro_popup_wrapper');

		var item_id = $cispro_popup.attr("item_id");

		//get data
		var slider_data = $("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_popup_data').html();
		var slider_data_array = slider_data.split(',');
		var cispro_popup_icons_opacity = parseInt(slider_data_array[11]) / 100;
		var cispro_popup_show_icons = parseInt(slider_data_array[12]);

		var op_pasive = cispro_popup_icons_opacity;
		$('.cispro_popup_autoplay_play').attr("op",op_pasive);
		$('.cispro_popup_autoplay_pause').attr("op",op_pasive);
		$('.cispro_popup_close').attr("op",op_pasive);

		var cispro_popup_show_topright_icons_ident = cispro_popup_show_icons;

		//delete previously declired hover function
		$cispro_popup.off('mouseenter.cispro_popup_show_topright_icons_hover_handler');
		$cispro_popup.off('mouseleave.cispro_popup_show_topright_icons_hover_handler');

		// order info showing type
		if(cispro_popup_show_topright_icons_ident == 0) {//never show
			// Do Nothing
		}
		else if(cispro_popup_show_topright_icons_ident == 1) {//show on hover
			// show arrows
			cispro_popup_show_topright_icons();

			// set hover functions
			$cispro_popup.on('mouseenter.cispro_popup_show_topright_icons_hover_handler', function() {
				cispro_popup_show_topright_icons();
			});
			$cispro_popup.on('mouseleave.cispro_popup_show_topright_icons_hover_handler', function() {
				cispro_popup_hide_topright_icons();
			});
			
		}
		else { //always show
			cispro_popup_show_topright_icons();
		}

	};

	/*
	// Function to show popup top-right icons
	*/
	var cispro_popup_topright_icons_timeout1 = '';
	var cispro_popup_topright_icons_timeout2 = '';
	function cispro_popup_show_topright_icons() {
		var $cispro_popup = $('.cispro_popup_wrapper');

		//if animation in progress, do not show arrows
		if($cispro_popup.hasClass('cispro_popup_in_progress'))
			return;

		//clear timeouts
		clearTimeout(cispro_popup_topright_icons_timeout1);
		clearTimeout(cispro_popup_topright_icons_timeout2);

		var op_pasive = $('.cispro_popup_close').attr("op");

		cispro_popup_topright_icons_timeout1 = setTimeout(function() {
			$('.cispro_popup_close').removeClass('disable_click').stop(true,false).animate({
				'opacity': op_pasive
				// 'top': '12px'
			},400,'easeOutBack');
			$('.cispro_popup_autoplay_play').removeClass('disable_click').stop(true,false).animate({
				'opacity': op_pasive
				// 'top': '12px'
			},400,'easeOutBack');
			$('.cispro_popup_autoplay_pause').removeClass('disable_click').stop(true,false).animate({
				'opacity': op_pasive
				// 'top': '12px'
			},400,'easeOutBack');
		},100);
	};
	function cispro_popup_hide_topright_icons() {
		var $cispro_popup = $('.cispro_popup_wrapper');

		//clear timeouts
		clearTimeout(cispro_popup_topright_icons_timeout1);
		clearTimeout(cispro_popup_topright_icons_timeout2);
		
		$('.cispro_popup_close').stop(true,false).fadeTo(400,0,function() {
			// $(this).css('top','-30px');
		});
		$('.cispro_popup_autoplay_play').stop(true,false).fadeTo(400,0,function() {
			// $(this).css('top','-30px');
		});
		$('.cispro_popup_autoplay_pause').stop(true,false).fadeTo(400,0,function() {
			// $(this).css('top','-30px');
		});

	};

	/*
	// Function to show popup item order info
	*/
	var cispro_popup_item_order_timeout1 = '';
	var cispro_popup_item_order_timeout2 = '';
	function cispro_popup_show_item_order() {
		var $cispro_popup = $('.cispro_popup_wrapper');
		var item_id = $cispro_popup.attr("item_id");

		//get data
		var slider_data = $("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_popup_data').html();
		var slider_data_array = slider_data.split(',');
		var cispro_popup_image_order_opacity = parseInt(slider_data_array[8]) / 100;
		var cispro_popup_image_order_top_offset = parseInt(slider_data_array[9]);

		//if animation in progress, do not show arrows
		if($cispro_popup.hasClass('cispro_popup_in_progress'))
			return;

		//clear timeouts
		clearTimeout(cispro_popup_item_order_timeout1);
		clearTimeout(cispro_popup_item_order_timeout2);

		var op_pasive = cispro_popup_image_order_opacity;

		cispro_popup_item_order_timeout1 = setTimeout(function() {
			$('.cispro_popup_item_order_info').stop(true,false).animate({
				'opacity': op_pasive,
				'top': cispro_popup_image_order_top_offset
			},400,'easeOutBack');
		},100);
	};
	function cispro_popup_hide_item_order() {
		var $cispro_popup = $('.cispro_popup_wrapper');

		//clear timeouts
		clearTimeout(cispro_popup_item_order_timeout1);
		clearTimeout(cispro_popup_item_order_timeout2);
		
		$('.cispro_popup_item_order_info').stop().fadeTo(400,0,function() {
			$(this).css('top','-30px');
		});
		
	};

	/*
	// Function to show/hide popup arrows
	*/
	var cispro_popup_arrows_timeout1 = '';
	var cispro_popup_arrows_timeout2 = '';
	function cispro_popup_show_arrows() {
		var $cispro_popup = $('.cispro_popup_wrapper');
		var item_id = $cispro_popup.attr("item_id");

		//get data
		var slider_data = $("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_popup_data').html();
		var slider_data_array = slider_data.split(',');
		var cispro_popup_arrow_passive_opacity = parseInt(slider_data_array[3]) / 100;
		var cispro_popup_arrow_left_offset = parseInt(slider_data_array[4]);

		//if animation in progress, do not show arrows
		if($cispro_popup.hasClass('cispro_popup_in_progress'))
			return;

		//clear timeouts
		clearTimeout(cispro_popup_arrows_timeout1);
		clearTimeout(cispro_popup_arrows_timeout2);
		
		var $left_arrow = $cispro_popup.find('.cispro_popup_left_arrow');
		var $right_arrow = $cispro_popup.find('.cispro_popup_right_arrow');
		
		var corner_offset = cispro_popup_arrow_left_offset;
		var op_passive = cispro_popup_arrow_passive_opacity;
		
		var animation_time = 400;
		var start_offset = -64;
		var effect = 'easeOutBack';
		
		cispro_popup_arrows_timeout1 = setTimeout(function() {
			$left_arrow.stop(true,false).animate({
				'left': corner_offset,
				'opacity': op_passive
			},animation_time,effect);
			
			$right_arrow.stop(true,false).animate({
				'right': corner_offset,
				'opacity': op_passive
			},animation_time,effect);
		},100);
		
	};
	function cispro_popup_hide_arrows() {
		var $cispro_popup = $('.cispro_popup_wrapper');

		//clear timeouts
		clearTimeout(cispro_popup_arrows_timeout1);
		clearTimeout(cispro_popup_arrows_timeout2);
		
		var $left_arrow = $cispro_popup.find('.cispro_popup_left_arrow');
		var $right_arrow = $cispro_popup.find('.cispro_popup_right_arrow');

		$left_arrow.fadeTo(200,0.2);
		$right_arrow.fadeTo(200,0.2);
		
		var animation_time = 400;
		var start_offset = -64;
		var effect = 'easeInBack';
		
		cispro_popup_arrows_timeout2 = setTimeout(function() {
			$left_arrow.stop(true,false).animate({
				'left': start_offset
			},animation_time,effect);
			
			$right_arrow.stop(true,false).animate({
				'right': start_offset
			},animation_time,effect);
		},200);
	};

	// popup top right  functions
	$('.cispro_popup_close').on('click', function() {
		cispro_reset_creative_popup();
	});

	$('.cispro_popup_close').on('mouseenter', function() {
		if($(this).hasClass('disable_click'))
			return;

		$(this).stop(true,false).animate({
			'opacity' : 1
		},300);
	});
	$('.cispro_popup_close').on('mouseleave', function() {
		if($(this).hasClass('disable_click'))
			return;

		var opacity_inactive = $(this).attr("op");
		$(this).stop(true,false).animate({
			'opacity' : opacity_inactive
		},300);
	});	

	$('.cispro_popup_autoplay_play').on('mouseenter', function() {
		if($(this).hasClass('disable_click'))
			return;

		$(this).stop(true,false).animate({
			'opacity' : 1
		},300);		

	});
	$('.cispro_popup_autoplay_play').on('mouseleave', function() {
		if($(this).hasClass('disable_click'))
			return;

		var opacity_inactive = $(this).attr("op");
		$(this).stop(true,false).animate({
			'opacity' : opacity_inactive
		},300);	

	});	
	$('.cispro_popup_autoplay_pause').on('mouseenter', function() {
		if($(this).hasClass('disable_click'))
			return;

		$(this).stop(true,false).animate({
			'opacity' : 1
		},300);		
	
	});
	$('.cispro_popup_autoplay_pause').on('mouseleave', function() {
		if($(this).hasClass('disable_click'))
			return;

		var opacity_inactive = $(this).attr("op");
		$(this).stop(true,false).animate({
			'opacity' : opacity_inactive
		},300);		

	});

	// popup item order info hover functions
	$('.cispro_popup_item_order_info').on('mouseenter', function() {
		$(this).stop(true,false).animate({
			'opacity' : 1
		},300);
	});
	$('.cispro_popup_item_order_info').on('mouseleave', function() {
		var opacity_inactive = $(this).attr("op");
		$(this).stop(true,false).animate({
			'opacity' : opacity_inactive
		},300);
	});

	// popup arrows hover functions
	$('.cispro_popup_left_arrow').on('mouseenter', function() {
		$(this).animate({
			'opacity' : 1
		},300);
	});
	$('.cispro_popup_left_arrow').on('mouseleave', function() {
		var opacity_inactive = $(this).attr("op");
		$(this).animate({
			'opacity' : opacity_inactive
		},300);
	});	
	$('.cispro_popup_right_arrow').on('mouseenter', function() {
		$(this).animate({
			'opacity' : 1
		},300);
	});
	$('.cispro_popup_right_arrow').on('mouseleave', function() {
		var opacity_inactive = $(this).attr("op");
		$(this).animate({
			'opacity' : opacity_inactive
		},300);
	});

	// popup autoplay functions //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	var cispro_popup_autoplay_start_timeout = '';
	function cispro_popup_prepare_autoplay() {
		var $cispro_popup = $('.cispro_popup_wrapper');
		var item_id = $cispro_popup.attr("item_id");

		// show play icon
		$('.cispro_popup_autoplay_pause').addClass('cispro_popup_topright_icon_hidden');
		$('.cispro_popup_autoplay_play').removeClass('cispro_popup_topright_icon_hidden');

		//fixed bug
		$('.cispro_popup_autoplay_bar').stop(true,false).css('width','0%');

		//get data
		var slider_data = $("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_popup_data').html();
		var slider_data_array = slider_data.split(',');
		var cispro_popup_autoplay_default = parseInt(slider_data_array[13]);

		var cispro_popup_autoplay_enabled = cispro_popup_autoplay_default;
		var cispro_popup_autoplay_index = parseInt($cispro_popup.attr("cispro_popup_autoplay"));

		if((cispro_popup_autoplay_index == 2 && cispro_popup_autoplay_enabled == 1) || cispro_popup_autoplay_index == 1 ) {
			cispro_popup_autoplay_start_timeout = setTimeout(function() {
				cispro_popup_make_autoplay_start();
			},1200);
		}

		// autoplay hover functionality - will be activated, if will be requested!
		// var cispro_popup_autoplay_ident = 1;//if 1, turn on autoplay hover functionlaity, if 2 - no!

		//delete previously declired hover function
		// $cispro_popup.off('mouseenter.cispro_popup_autoplay_hover_handler');
		// $cispro_popup.off('mouseleave.cispro_popup_autoplay_hover_handler');

		// if(cispro_popup_autoplay_ident == 1) {//show on hover
		// 	// show arrows
		// 	cispro_popup_make_autoplay_start();

		// 	// set hover functions
		// 	$cispro_popup.on('mouseenter.cispro_popup_autoplay_hover_handler', function() {
		// 		cispro_popup_make_autoplay_stop();
		// 	});
		// 	$cispro_popup.on('mouseleave.cispro_popup_autoplay_hover_handler', function() {
		// 		cispro_popup_make_autoplay_start();
		// 	});
			
		// }
		// else { //always show
		// 	cispro_popup_make_autoplay_start();
		// }
	};

	$('.cispro_popup_autoplay_play').on('click', function() {
		if($(this).hasClass('disable_click'))
			return;
		cispro_popup_make_autoplay_start();
	});	
	$('.cispro_popup_autoplay_pause').on('click', function() {
		if($(this).hasClass('disable_click'))
			return;	
		cispro_popup_make_autoplay_stop();
	});

	function cispro_popup_make_autoplay_start() {
		var $cispro_popup = $('.cispro_popup_wrapper');

		//clear auto-play timeout
		clearTimeout(cispro_popup_autoplay_start_timeout);
		// toggle icons
		$('.cispro_popup_autoplay_play').addClass('cispro_popup_topright_icon_hidden');
		$('.cispro_popup_autoplay_pause').removeClass('cispro_popup_topright_icon_hidden');

		// set autoplay turned on
		$cispro_popup.attr("cispro_popup_autoplay","1");

		//strat autoplay
		cispro_popup_autoplay_start();
	};
	function cispro_popup_make_autoplay_stop() {
		var $cispro_popup_autoplay_bar = $('.cispro_popup_autoplay_bar');

		var bar_curr_width = parseFloat($cispro_popup_autoplay_bar.width());
		var bar_total_width = parseFloat($cispro_popup_autoplay_bar.parent('div').width());
		var curr_perc = 100 * bar_curr_width / bar_total_width;

		if(curr_perc > 98) {
			return;
		}
		// toggle icons
		$('.cispro_popup_autoplay_pause').addClass('cispro_popup_topright_icon_hidden');
		$('.cispro_popup_autoplay_play').removeClass('cispro_popup_topright_icon_hidden');

		//strat autoplay
		cispro_popup_autoplay_stop();
	};

	function cispro_popup_autoplay_start() {
		var $cispro_popup = $('.cispro_popup_wrapper');
		var item_id = $cispro_popup.attr("item_id");

		var $cispro_popup_autoplay_bar = $('.cispro_popup_autoplay_bar');

		//get data
		var slider_data = $("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_popup_data').html();
		var slider_data_array = slider_data.split(',');
		var cispro_popup_autoplay_time = parseInt(slider_data_array[15]);

		var animation_time = cispro_popup_autoplay_time;

		var bar_curr_width = parseFloat($cispro_popup_autoplay_bar.width());
		var bar_total_width = parseFloat($cispro_popup_autoplay_bar.parent('div').width());
		var curr_perc = 100 * bar_curr_width / bar_total_width;

		var remained_perc = 100 - curr_perc;
		var animation_time_remained = animation_time * remained_perc / 100;

		$cispro_popup_autoplay_bar.stop(true,false).animate({
			'width': '100%'
		},animation_time_remained,'linear', function() {

			$('.cispro_popup_close').addClass('disable_click');
			$('.cispro_popup_autoplay_pause').addClass('disable_click');
			$('.cispro_popup_autoplay_play').addClass('disable_click');

			cispro_popup_show_next_item();
		});

	};

	function cispro_popup_autoplay_stop() {
		var $cispro_popup = $('.cispro_popup_wrapper');

		//clear auto-play timeout
		clearTimeout(cispro_popup_autoplay_start_timeout);

		// set autoplay turned off
		$cispro_popup.attr("cispro_popup_autoplay","0");

		var $cispro_popup_autoplay_bar = $('.cispro_popup_autoplay_bar');
		var bar_curr_width = parseInt($cispro_popup_autoplay_bar.width());
		var animate_back_time = bar_curr_width * 0.9;

		$cispro_popup_autoplay_bar.stop(true,false).animate({
			'width':'0%'
		},animate_back_time,'linear');

	};

	// popup arrow functions ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	$('.cispro_popup_right_arrow').on('click', function() {
		cispro_popup_show_next_item();
	});
	$('.cispro_popup_left_arrow').on('click', function() {
		cispro_popup_show_prev_item();
	});

	function cispro_popup_show_next_item() {
		var $cispro_popup = $('.cispro_popup_wrapper');

		//check if popup is ready
		if($cispro_popup.hasClass('cispro_popup_in_progress'))
			return;

		var item_id = parseInt($cispro_popup.attr("item_id"));
		var $original_item = $("#cispro_item_" + item_id);

		//get data
		var slider_data = $("#cispro_item_" + item_id).parents('.cispro_main_wrapper').find('.cispro_popup_data').html();
		var slider_data_array = slider_data.split(',');
		var cispro_popup_closeonend = parseInt(slider_data_array[14]);

		var slider_id = parseInt($original_item.parents('.cispro_main_wrapper').attr("cispro_slider_id"));
		var item_order = parseInt($original_item.attr("cispro_popup_order"));
		var cispro_popup_items_length = parseInt($original_item.parents('.cispro_main_wrapper').attr("cispro_popup_items_count"));

		// if last item, return
		if(item_order == cispro_popup_items_length) {
			var cispro_popup_last_item_behaviour = cispro_popup_closeonend;

			if(cispro_popup_last_item_behaviour == 1) {
				//close creative popup, if last item
				cispro_reset_creative_popup();
			}
			else {
				// show play icon
				$('.cispro_popup_autoplay_pause').addClass('cispro_popup_topright_icon_hidden');
				$('.cispro_popup_autoplay_play').removeClass('cispro_popup_topright_icon_hidden');

				//reset bar
				$('.cispro_popup_autoplay_bar').stop(true,false).animate({
					'width': '0%'
				},400,'swing');
			}
			return;
		}
		else {
			var active_item_id = parseInt($original_item.nextAll('.cispro_row_item.cispro_has_popup').first().attr("item_id"));

			//hide arrows 
			cispro_popup_hide_arrows();
			//hide image order data
			cispro_popup_hide_item_order();
			//hide popup autoplay bar
			cispro_popup_hide_autoplay_bar();
			//hide tpright arrows
			cispro_popup_hide_topright_icons();

			// set animation progress class
			$cispro_popup.addClass('cispro_popup_in_progress');

			// the hiding animation accurs in 600ms, so we will hide existing item in that time 
			var bottom_h = parseInt($cispro_popup.find('.cispro_popup_bottom_holder').attr("h"));

			//animate main popup
			$cispro_popup.stop().animate({
				'height':'-=' + bottom_h
			},600,'swing', function() {
				$('.cispro_popup_bottom_inner_wrapper').remove()
			});

			//animate bottom holder
			$('.cispro_popup_bottom_holder').animate({
				'height': 0
			},600,'swing');

			$('.cispro_popup_item').stop().fadeTo(600,0, function() {
				$(this).remove();

				//show new item
				cispro_show_image(active_item_id);
			});
		};
	};

	function cispro_popup_show_prev_item() {
		var $cispro_popup = $('.cispro_popup_wrapper');

		//check if popup is ready
		if($cispro_popup.hasClass('cispro_popup_in_progress'))
			return;

		var item_id = parseInt($cispro_popup.attr("item_id"));
		var $original_item = $("#cispro_item_" + item_id);

		var slider_id = parseInt($original_item.parents('.cispro_main_wrapper').attr("cispro_slider_id"));
		var item_order = parseInt($original_item.attr("cispro_popup_order"));
		var cispro_popup_items_length = parseInt($original_item.parents('.cispro_main_wrapper').attr("cispro_popup_items_count"));

		// if first item, return
		if(item_order == 1) {
			return;
		}
		else {
			var active_item_id = parseInt($original_item.prevAll('.cispro_row_item.cispro_has_popup').first().attr("item_id"));

			//hide arrows 
			cispro_popup_hide_arrows();
			//hide image order data
			cispro_popup_hide_item_order();
			//hide popup autoplay bar
			cispro_popup_hide_autoplay_bar();
			//hide tpright arrows
			cispro_popup_hide_topright_icons();

			// set animation progress class
			$cispro_popup.addClass('cispro_popup_in_progress');

			// the hiding animation accurs in 600ms, so we will hide existing item in that time 
			var bottom_h = parseInt($cispro_popup.find('.cispro_popup_bottom_holder').attr("h"));

			//animate main popup
			$cispro_popup.stop().animate({
				'height':'-=' + bottom_h
			},600,'swing', function() {
				$('.cispro_popup_bottom_inner_wrapper').remove()
			});

			//animate bottom holder
			$('.cispro_popup_bottom_holder').animate({
				'height': 0
			},600,'swing');

			$('.cispro_popup_item').stop().fadeTo(600,0, function() {
				$(this).remove();

				//show new item
				cispro_show_image(active_item_id);
			});
		};
	};

	//Popup autoplay bar ////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

	function cispro_popup_show_autoplay_bar() {
		setTimeout(function() {
			$('.cispro_popup_autoplay_bar_holder').stop().animate({
				'opacity': '0.8'
			},400,'swing');
		},100);
	};

	function cispro_popup_hide_autoplay_bar() {
		$('.cispro_popup_autoplay_bar_holder').stop(true,false).animate({
			'opacity': '0'
		},400,'swing');
		$('.cispro_popup_autoplay_bar').stop(true,false).animate({
			'width': '0%'
		},400,'swing');
	};

	//slider correction////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	$('.cispro_row_item').mouseenter(function() {
		cispro_make_slider_item_correction($(this));
	});

	function cispro_make_slider_item_correction($elem) {
		var $loader = $elem.find('.cispro_row_item_loader'); 
		var slider_id = $loader.parents('.cispro_main_wrapper').attr("cispro_slider_id");
		var item_id = $loader.parents('.cispro_row_item').attr("item_id");

		// get total items width
		var items_w = parseInt($loader.parents('.cispro_main_wrapper').find('.cispro_images_holder').width());
		var total_w = parseInt($loader.parents('.cispro_main_wrapper').find('.cispro_images_row').width());

		//check if slider in scroll progress, then return
		if($loader.parents('.cispro_main_wrapper').find('.cispro_images_holder').hasClass('cispro_scrolling') || $loader.parents('.cispro_main_wrapper').find('.cispro_images_holder').hasClass('cispro_autoplay_back_animation') || items_w < total_w)
			return;

		var $cispro_popup = $('.cispro_popup_wrapper');

		var loader_width = parseInt($loader.css('width'));
		var items_m_r = parseInt($loader.parents('.cispro_row_item').css('margin-right'));

		//get slider_offset
		var image_index = $loader.parents('.cispro_row_item').attr("cispro_item_order");
		var total_items_width = 0;
		$loader.parents('.cispro_main_wrapper').find('.cispro_row_item').each(function(i) {
			var w = parseInt($(this).width());
			var m_r = parseInt($(this).css('margin-right'));
			total_items_width = total_items_width + 1*w + 1*m_r;
			if(i == image_index)
				return false;
		});

		var current_left_offset = Math.abs(parseInt($loader.parents('.cispro_main_wrapper').find('.cispro_images_holder').css('margin-left')));
		var wrapper_width = parseInt($loader.parents('.cispro_main_wrapper').width());

		var offset1 = total_items_width - current_left_offset;
		var direction = 0;
		var item_offset_to_move = 0;
		if(offset1 >= wrapper_width) {
			var item_offset = total_items_width - current_left_offset - wrapper_width - items_m_r;
			var item_offset_to_move = item_offset < 0 ? 0 : item_offset;
		}
		else {
			if(offset1 < loader_width) {
				var item_offset_to_move = loader_width - offset1 + 1*items_m_r;
				direction = 1;
			}
		};

		// BUG FIX
		var current_left_offset_with_sign = parseInt($loader.parents('.cispro_main_wrapper').find('.cispro_images_holder').css('margin-left'));
		if(direction == 1 && item_offset_to_move > 0 && image_index == 0 && current_left_offset_with_sign >= 0)
			return;

		var popup_loader_animate_timeout = 400;
		if(item_offset_to_move > 0) {
			// popup_loader_animate_timeout = Math.abs(item_offset_to_move) * 4;
			if(direction == 1) {
				$loader.parents('.cispro_main_wrapper').find('.cispro_images_holder').stop(true,false).animate({
					'margin-left': "+=" + item_offset_to_move
				},popup_loader_animate_timeout,'swing');
			}
			else {
				$loader.parents('.cispro_main_wrapper').find('.cispro_images_holder').stop(true,false).animate({
					'margin-left': "-=" + item_offset_to_move
				},popup_loader_animate_timeout,'swing');
			};
		};
	};

	// slider autoplay///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
	var cispro_evenly_move_intervals = new Array();
	var cispro_autoplay_start_timeouts = new Array();
	var cispro_autoplay_animate_back_timeouts = new Array();
	function cispro_make_autoplay() {
		$(".cispro_main_wrapper").each(function() {
			$wrapper = $(this);
			//get autoplay data
			var slider_data = $wrapper.find('.cispro_moving_data').html();
			var slider_data_array = slider_data.split(',');
			var slider_autoplay = parseInt(slider_data_array[3]);
			var slider_autoplay_start_timeout = parseInt(slider_data_array[4]); 
			var slider_autoplay_step_timeout = parseInt(slider_data_array[5]);
			var slider_autoplay_evenly_speed = parseInt(slider_data_array[6]);
			
			if(slider_autoplay == 0) {
				return;
			}
			else if(slider_autoplay == 1) {
				cispro_make_evenly_autoplay($wrapper);
			}
			else if(slider_autoplay == 2) {
				cispro_make_steps_autoplay($wrapper);
			}
		});
	};
	cispro_make_autoplay();
	
	function cispro_make_steps_autoplay($wrapper) {
		var slider_id = $wrapper.attr("roll");
		
		var slider_data = $wrapper.find('.cispro_moving_data').html();
		var slider_data_array = slider_data.split(',');
		var slider_autoplay_start_timeout = parseInt(slider_data_array[4]);
		var slider_autoplay_step_timeout = parseInt(slider_data_array[5]);
		var slider_autoplay_restart_timeout = parseInt(slider_data_array[7]);
		
		cispro_autoplay_animate_back_timeouts[slider_id] = '';
		
		cispro_autoplay_start_timeouts[slider_id] = setTimeout(function() {//set timeout
			//set interval
			cispro_evenly_move_intervals[slider_id] = setInterval(function() {
				cispro_move_slider_by_steps($wrapper);
			},slider_autoplay_step_timeout);
		},slider_autoplay_start_timeout);
		
		$wrapper.hover(function() {
			clearTimeout(cispro_autoplay_start_timeouts[slider_id]);
			clearTimeout(cispro_autoplay_animate_back_timeouts[slider_id]);
			clearInterval(cispro_evenly_move_intervals[slider_id]);
			$wrapper.addClass('cispro_mouseentered');
		},function() {
			//check if popup vissible///////////////////////////////////
			var $cispro_popup = $('.cispro_popup_wrapper');
			var popup_slider_id = $cispro_popup.attr("slider_id");
			if($cispro_popup.hasClass('cispro_vissible') && popup_slider_id == slider_id) {
				return;
			}

			cispro_autoplay_start_timeouts[slider_id] = setTimeout(function() {//set timeout
				//set interval
				cispro_evenly_move_intervals[slider_id] = setInterval(function() {
					cispro_move_slider_by_steps($wrapper);
				},slider_autoplay_step_timeout);
			},slider_autoplay_restart_timeout);
			$wrapper.removeClass('cispro_mouseentered');
		});
	};
	
	function cispro_move_slider_by_steps($wrapper) {
		var slider_id = $wrapper.attr("roll");
		
		var slider_data = $wrapper.find('.cispro_moving_data').html();
		var slider_data_array = slider_data.split(',');
		var slider_autoplay_start_timeout = parseInt(slider_data_array[4]);
		var slider_autoplay_step_timeout = parseInt(slider_data_array[5]);
		
		$cispro_images_holder = $wrapper.find('.cispro_images_holder');
		var screen_w = parseFloat($cispro_images_holder.parent('div').width());
		var total_w = parseFloat($cispro_images_holder.width());
		
		if(total_w >= screen_w)
			var result = cispro_move_images_holder_left($cispro_images_holder);
		else
			var result = cispro_move_images_holder_right($cispro_images_holder);
		
		if(result == 'end') {
			clearTimeout(cispro_autoplay_start_timeouts[slider_id]);
			clearInterval(cispro_evenly_move_intervals[slider_id]);
			
			var cispro_animate_back_to_start_timeout = slider_autoplay_step_timeout;
			var cispro_animate_back_to_start_time = Math.abs(parseInt((total_w - screen_w) * 1.5));
			cispro_animate_back_to_start_time = cispro_animate_back_to_start_time < 600 ? 600 : cispro_animate_back_to_start_time;

			var $sl = $('.cispro_wrapper_' + slider_id).find('.cispro_images_holder');;
			//set timeout to animate back
			cispro_autoplay_animate_back_timeouts[slider_id] = setTimeout(function() {
				$sl.addClass('cispro_autoplay_back_animation');
				//animate back to start
				$sl.stop(true,false).animate({
					'margin-left': 0
				},cispro_animate_back_to_start_time,'easeOutBack', function() {
					var $sl = $('.cispro_wrapper_' + slider_id);
					$sl.find('.cispro_images_holder').removeClass('cispro_autoplay_back_animation');

					//check to see that mouseenter does not happened
					if($wrapper.hasClass('cispro_mouseentered'))
						return;
					
					//set new autoplay
					cispro_autoplay_start_timeouts[slider_id] = setTimeout(function() {//set timeout
						//set interval
						cispro_evenly_move_intervals[slider_id] = setInterval(function() {
							cispro_move_slider_by_steps($sl);
						},slider_autoplay_step_timeout);
					},slider_autoplay_start_timeout);
				});
			},cispro_animate_back_to_start_timeout);
				
		}
	};
	
	var cispro_interval_time = 250;
	function cispro_make_evenly_autoplay($wrapper) {
		var slider_id = $wrapper.attr("roll");
		
		var slider_data = $wrapper.find('.cispro_moving_data').html();
		var slider_data_array = slider_data.split(',');
		var slider_autoplay_start_timeout = parseInt(slider_data_array[4]);
		var slider_autoplay_restart_timeout = parseInt(slider_data_array[7]);
		
		cispro_autoplay_animate_back_timeouts[slider_id] = '';
		
		cispro_autoplay_start_timeouts[slider_id] = setTimeout(function() {//set timeout
			//set interval
			cispro_evenly_move_intervals[slider_id] = setInterval(function() {
				cispro_move_slider_evenly($wrapper);
			},cispro_interval_time);
		},slider_autoplay_start_timeout);
		
		$wrapper.hover(function() {
			clearTimeout(cispro_autoplay_start_timeouts[slider_id]);
			clearTimeout(cispro_autoplay_animate_back_timeouts[slider_id]);
			clearInterval(cispro_evenly_move_intervals[slider_id]);
			$wrapper.addClass('cispro_mouseentered');
		},function() {
			//check if popup vissible///////////////////////////////////
			var $cispro_popup = $('.cispro_popup_wrapper');
			var popup_slider_id = $cispro_popup.attr("slider_id");
			if($cispro_popup.hasClass('cispro_vissible') && popup_slider_id == slider_id) {
				return;
			}

			cispro_autoplay_start_timeouts[slider_id] = setTimeout(function() {//set timeout
				//set interval
				cispro_evenly_move_intervals[slider_id] = setInterval(function() {
					cispro_move_slider_evenly($wrapper);
				},cispro_interval_time);
			},slider_autoplay_restart_timeout);
			$wrapper.removeClass('cispro_mouseentered');
		});
	};
	
	function cispro_move_slider_evenly($wrapper) {
		var slider_id = $wrapper.attr("roll");
		
		//get autoplay data
		var slider_data = $wrapper.find('.cispro_moving_data').html();
		var slider_data_array = slider_data.split(',');
		var slider_autoplay_start_timeout = parseInt(slider_data_array[4]);
		var slider_autoplay_evenly_speed = parseInt(slider_data_array[6]);
		
		$cispro_images_holder = $wrapper.find('.cispro_images_holder');
		var screen_w = parseFloat($cispro_images_holder.parent('div').width());
		var total_w = parseFloat($cispro_images_holder.width());
		var curr_left = parseFloat($cispro_images_holder.css('margin-left'));
		curr_left = (total_w >= screen_w) ? curr_left - slider_autoplay_evenly_speed : curr_left + 1 * slider_autoplay_evenly_speed;
		
		var cispro_single_autoplay_time = 400;
		var cispro_autoplay_ease_time = 600;
		var cispro_animate_back_to_start_timeout = 2000;
		var cispro_animate_back_to_start_time = Math.abs(parseInt((total_w - screen_w) * 1.5));
		cispro_animate_back_to_start_time = cispro_animate_back_to_start_time < 600 ? 600 : cispro_animate_back_to_start_time;
		
		var slider_data = $wrapper.find('.cispro_moving_data').html();
		var slider_data_array = slider_data.split(',');
		var delta_offset = parseInt(slider_data_array[0]);
		var move_speed_time = parseInt(slider_data_array[1]); 
		var ease_effect = parseInt(slider_data_array[2]);
		var cispro_effect_type = 'swing';
		
		ease_effect = slider_autoplay_evenly_speed;
		
		if(total_w >= screen_w) {
			//check if end
			if(Math.abs(curr_left) + 1 * screen_w >= total_w) {
				clearTimeout(cispro_autoplay_start_timeouts[slider_id]);
				clearInterval(cispro_evenly_move_intervals[slider_id]);
				
				var desired_left = screen_w - total_w;
				var desired_left_1 = desired_left;
				desired_left_1 = (total_w < screen_w) ? desired_left_1 + ease_effect * 1 : desired_left_1 - ease_effect * 1; 
				
				//calculate last point speed
				var curr_left_final = parseFloat($cispro_images_holder.css('margin-left'));
				var move_speed_time_final = Math.abs(curr_left_final - desired_left_1) * cispro_single_autoplay_time  / slider_autoplay_evenly_speed;
				$cispro_images_holder.stop(true,false).animate({//swing effect
					'margin-left': desired_left_1
				},move_speed_time_final,cispro_effect_type,function() {
					//easing animation on end
					var $sl = $('.cispro_wrapper_' + slider_id).find('.cispro_images_holder');
					$sl.stop().animate({
						'margin-left': desired_left
					},cispro_autoplay_ease_time,'easeOutBack', function() {
						
						//check to see that mouseenter does not happened
						if($wrapper.hasClass('cispro_mouseentered'))
							return;
						
						var $sl = $('.cispro_wrapper_' + slider_id).find('.cispro_images_holder');
						//set timeout to animate back
						cispro_autoplay_animate_back_timeouts[slider_id] = setTimeout(function() {
							//animate back to start
							$sl.addClass('cispro_autoplay_back_animation');
							$sl.stop(true,false).animate({
								'margin-left': 0
							},cispro_animate_back_to_start_time,'easeOutBack', function() {
								var $sl = $('.cispro_wrapper_' + slider_id);

								$sl.find('.cispro_images_holder').removeClass('cispro_autoplay_back_animation');
								//check to see that mouseenter does not happened
								if($wrapper.hasClass('cispro_mouseentered'))
									return;
								
								//set new autoplay
								cispro_autoplay_start_timeouts[slider_id] = setTimeout(function() {//set timeout
									//set interval
									cispro_evenly_move_intervals[slider_id] = setInterval(function() {
										cispro_move_slider_evenly($sl);
									},cispro_interval_time);
								},slider_autoplay_start_timeout);
							});
						},cispro_animate_back_to_start_timeout);
					});
				});
			}
			else {
				$cispro_images_holder.stop(true,false).animate({
					'margin-left': curr_left
				},cispro_single_autoplay_time,'linear');
			}
		}
		else {
			//check if end
			if(Math.abs(curr_left) + 1 * total_w >= screen_w) {
				//clear timeouts, intervals
				clearTimeout(cispro_autoplay_start_timeouts[slider_id]);
				clearInterval(cispro_evenly_move_intervals[slider_id]);
				
				var desired_left = screen_w - total_w;
				var desired_left_1 = desired_left;
				desired_left_1 =  desired_left_1 + ease_effect * 1;
				
				//calculate last point speed
				var curr_left_final = parseFloat($cispro_images_holder.css('margin-left'));
				var move_speed_time_final = Math.abs(curr_left_final - desired_left_1) * cispro_single_autoplay_time  / slider_autoplay_evenly_speed;
				$cispro_images_holder.stop(true,false).animate({//swing effect
					'margin-left': desired_left_1
				},move_speed_time_final,cispro_effect_type,function() {
					//easing animation on end
					var $sl = $('.cispro_wrapper_' + slider_id).find('.cispro_images_holder');
					$sl.stop().animate({
						'margin-left': desired_left
					},cispro_autoplay_ease_time,'easeOutBack', function() {
						//check to see that mouseenter does not happened
						if($wrapper.hasClass('cispro_mouseentered'))
							return;
						var $sl = $('.cispro_wrapper_' + slider_id).find('.cispro_images_holder');
						//set timeout to animate back
						cispro_autoplay_animate_back_timeouts[slider_id] = setTimeout(function() {
							//animate back to start
							$sl.stop(true,false).animate({
								'margin-left': 0
							},cispro_animate_back_to_start_time,'easeOutBack', function() {
								//check to see that mouseenter does not happened
								if($wrapper.hasClass('cispro_mouseentered'))
									return;
								
								var $sl = $('.cispro_wrapper_' + slider_id);
								//set new autoplay
								cispro_autoplay_start_timeouts[slider_id] = setTimeout(function() {//set timeout
									//set interval
									cispro_evenly_move_intervals[slider_id] = setInterval(function() {
										cispro_move_slider_evenly($sl);
									},cispro_interval_time);
								},slider_autoplay_start_timeout);
							});
						},cispro_animate_back_to_start_timeout);
					});
				});
			}
			else {
				$cispro_images_holder.stop(true,false).animate({
					'margin-left': curr_left
				},cispro_single_autoplay_time,'linear');
			}
		}
		
	};
	
	//arrows
	function cispro_prepare_arrows() {
		$(".cispro_main_wrapper").each(function() {
			var $wrapper = $(this);
			var $left_arrow = $wrapper.find('.cispro_button_left');
			var $right_arrow = $wrapper.find('.cispro_button_right');
			
			//get arrows data
			var arr_data = $wrapper.find('.cispro_arrow_data').html();
			var arr_data_array = arr_data.split(',');
			var arrow_width = arr_data_array[0];
			var arrow_corner_offset = arr_data_array[1];
			var arrow_middle_offset = arr_data_array[2];
			var arrow_opacity = arr_data_array[3] / 100;
			var show_arrows = arr_data_array[4];
			
			//set data
			$left_arrow.attr("op",arrow_opacity);
			$left_arrow.attr("corner_offset",arrow_corner_offset);
			$right_arrow.attr("op",arrow_opacity);
			$right_arrow.attr("corner_offset",arrow_corner_offset);
			
			//set styles
			$left_arrow.css('width',arrow_width);
			$right_arrow.css('width',arrow_width);
			
			var arrow_height = parseInt ($left_arrow.height());
			var wrapper_height = parseFloat ($wrapper.height());
			var p_t = isNaN(parseFloat($wrapper.css('padding-top'))) ? 0 : parseFloat($wrapper.css('padding-top'));
			var p_b = isNaN(parseFloat($wrapper.css('padding-bottom'))) ? 0 : parseFloat($wrapper.css('padding-bottom'));
			var arrow_top_position = ((wrapper_height + 1 * p_t + 1 * p_b - arrow_height) / 2 ) + 1 * arrow_middle_offset;
			
			$left_arrow.css({
				'top': arrow_top_position,
				'left': '-64px',
				'opacity': arrow_opacity
			});
			$right_arrow.css({
				'top': arrow_top_position,
				'right': '-64px',
				'opacity': arrow_opacity
			});
			
			if(show_arrows == 0) {//never show arrows
				$left_arrow.remove();
				$right_arrow.remove();
			}
			else if(show_arrows == 1) {//show on hover
				$wrapper.hover(function() {
					cispro_show_arrows($wrapper);
				}, function() {
					cispro_hide_arrows($wrapper);
				})
			}
			else {
				cispro_show_arrows($wrapper);
			}
		});
	};
	setTimeout(function() {
		cispro_prepare_arrows();
	},1200);
	
	var cispro_arrows_timeout1 = '';
	var cispro_arrows_timeout2 = '';
	function cispro_show_arrows($wrapper) {
		//clear timeouts
		clearTimeout(cispro_arrows_timeout1);
		clearTimeout(cispro_arrows_timeout2);
		
		var $left_arrow = $wrapper.find('.cispro_button_left');
		var $right_arrow = $wrapper.find('.cispro_button_right');
		
		var corner_offset = $left_arrow.attr("corner_offset");
		
		var animation_time = 400;
		var start_offset = -64;
		var effect = 'easeOutBack';
		
		cispro_arrows_timeout1 = setTimeout(function() {
			$left_arrow.stop(true,false).animate({
				'left': corner_offset
			},animation_time,effect);
			
			$right_arrow.stop(true,false).animate({
				'right': corner_offset
			},animation_time,effect);
		},100);
		
	};
	function cispro_hide_arrows($wrapper) {
		//clear timeouts
		clearTimeout(cispro_arrows_timeout1);
		clearTimeout(cispro_arrows_timeout2);
		
		var $left_arrow = $wrapper.find('.cispro_button_left');
		var $right_arrow = $wrapper.find('.cispro_button_right');
		
		var animation_time = 300;
		var start_offset = -64;
		var effect = 'easeInBack';
		
		cispro_arrows_timeout2 = setTimeout(function() {
			$left_arrow.stop(true,false).animate({
				'left': start_offset
			},animation_time,effect);
			
			$right_arrow.stop(true,false).animate({
				'right': start_offset
			},animation_time,effect);
		},200)
	};
	
//mousewheel**************************************************************
	$('.cispro_images_row').mousewheel(function(objEvent, intDelta) {
		if($(this).hasClass('cispro_scrolling_vertical'))
			return;
		if(intDelta > 0)
			cispro_move_images_holder_left($(this).find('.cispro_images_holder'));
		else 
			cispro_move_images_holder_right($(this).find('.cispro_images_holder'));
	});
	
	// setTimeout(function() {
	// 	//cispro_move_images_holder_right($('.cispro_images_holder'));
	// },250);
	
	//function to move left

	var cispro_effect_type = 'swing';
	var cispro_clear_timeout = '';
	var cispro_switch_move_direction = false;
	
	function cispro_move_images_holder_left($wrapper) {
		
		//get slider data
		var slider_data = $wrapper.parents('.cispro_main_wrapper ').find('.cispro_moving_data').html();
		var slider_data_array = slider_data.split(',');
		var delta_offset = parseInt(slider_data_array[0]);
		var move_speed_time = parseInt(slider_data_array[1]); 
		var ease_effect = parseInt(slider_data_array[2]);
		
		clearTimeout(cispro_clear_timeout);
		$('.cispro_images_holder').addClass('cispro_scrolling');
		cispro_clear_timeout = setTimeout(function() {
			$('.cispro_images_holder').removeClass('cispro_scrolling');
		},move_speed_time);
		
		var screen_w = parseFloat($wrapper.parent('div').width());
		var total_w = parseFloat($wrapper.width());
		var curr_left = parseFloat($wrapper.css('margin-left'));
		curr_left -= delta_offset;
		
		//check if end
		if(Math.abs(curr_left) + 1 * screen_w >= total_w) {
			var desired_left = screen_w - total_w;
			var desired_left_1 = desired_left;
			desired_left_1 = (total_w < screen_w) ? desired_left_1 + ease_effect * 1 : desired_left_1 - ease_effect * 1; 
			
			if(total_w < screen_w && !cispro_switch_move_direction) {
				cispro_switch_move_direction = true;
				cispro_move_images_holder_right($wrapper);
				cispro_switch_move_direction = false;
				return;
			}
			
			//calculate last point speed
			var curr_left_final = parseFloat($wrapper.css('margin-left'));
			var move_speed_time_final = Math.abs(curr_left_final - desired_left_1) * move_speed_time * 1.2  / delta_offset;
			$wrapper.stop(true,false).animate({
				'margin-left': desired_left_1
			},move_speed_time_final,cispro_effect_type,function() {
				$(this).stop().animate({
					'margin-left': desired_left
				},move_speed_time,'easeOutBack')
			});
			
			return 'end';
		}
		else {
			$wrapper.stop(true,false).animate({
				'margin-left': curr_left
			},move_speed_time,cispro_effect_type);
		}
		
	};
	function cispro_move_images_holder_right($wrapper) {
		
		//get slider data
		var slider_data = $wrapper.parents('.cispro_main_wrapper ').find('.cispro_moving_data').html();
		var slider_data_array = slider_data.split(',');
		var delta_offset = parseInt(slider_data_array[0]);
		var move_speed_time = parseInt(slider_data_array[1]); 
		var ease_effect = parseInt(slider_data_array[2]);
		
		clearTimeout(cispro_clear_timeout);
		$('.cispro_images_holder').addClass('cispro_scrolling');
		cispro_clear_timeout = setTimeout(function() {
			$('.cispro_images_holder').removeClass('cispro_scrolling');
		},move_speed_time);
		
		
		var screen_w = parseFloat($wrapper.parent('div').width());
		var total_w = parseFloat($wrapper.width());
		var curr_left = parseFloat($wrapper.css('margin-left'));
		curr_left += delta_offset;
		
		//check if start
		if(curr_left >= 0) {
			var desired_left = 0;
			var desired_left_1 = desired_left;
			desired_left_1 = (total_w < screen_w) ? desired_left_1 - ease_effect * 1 : desired_left_1 + ease_effect * 1;
			
			if(total_w < screen_w && !cispro_switch_move_direction) {
				cispro_switch_move_direction = true;
				var r = cispro_move_images_holder_left($wrapper);
				cispro_switch_move_direction = false;
				return r;
			}
			
			//calculate last point speed
			var curr_left_final = parseFloat($wrapper.css('margin-left'));
			var move_speed_time_final = Math.abs(curr_left_final - desired_left_1) * move_speed_time * 1.2 / delta_offset;
			$wrapper.stop(true,false).animate({
				'margin-left': desired_left_1
			},move_speed_time_final,cispro_effect_type,function() {
				$(this).stop().animate({
					'margin-left': desired_left
				},move_speed_time,'easeOutBack')
			});
			
			return 'end';
		}
		else {
			$wrapper.stop().animate({
				'margin-left': curr_left
			},move_speed_time,cispro_effect_type);
		}
	};
	
	//buttons
	$('.cispro_button_left').click(function() {
		var $cispro_wrapper = $(this).parents('.cispro_images_row').find('.cispro_images_holder');
		var screen_w = parseFloat($cispro_wrapper.parent('div').width());
		var total_w = parseFloat($cispro_wrapper.width());
		if(total_w < screen_w)
			cispro_move_images_holder_left($cispro_wrapper);
		else
			cispro_move_images_holder_right($cispro_wrapper);
	});
	$('.cispro_button_right').click(function() {
		var $cispro_wrapper = $(this).parents('.cispro_images_row').find('.cispro_images_holder');
		var screen_w = parseFloat($cispro_wrapper.parent('div').width());
		var total_w = parseFloat($cispro_wrapper.width());
		if(total_w < screen_w)
			cispro_move_images_holder_right($cispro_wrapper);
		else
			cispro_move_images_holder_left($cispro_wrapper);
	});
	$('.cispro_button_left').hover(function() {
		$(this).animate({
			'opacity' : 1
		},300);
	},function() {
		var opacity_inactive = $(this).attr("op");
		$(this).animate({
			'opacity' : opacity_inactive
		},300);
	});
	$('.cispro_button_right').hover(function() {
		$(this).animate({
			'opacity' : 1
		},300);
	},function() {
		var opacity_inactive = $(this).attr("op");
		$(this).animate({
			'opacity' : opacity_inactive
		},300);
	});
	
	//disable page scroll
	$('.cispro_images_row').bind('mousewheel DOMMouseScroll', function(e) {
	    var scrollTo = null;

	    if (e.type == 'mousewheel') {
	        scrollTo = (e.originalEvent.wheelDelta * -1);
	    }
	    else if (e.type == 'DOMMouseScroll') {
	        scrollTo = 40 * e.originalEvent.detail;
	    }

	    if (scrollTo) {
	        e.preventDefault();
	        $(this).scrollTop(scrollTo + $(this).scrollTop());
	    }
	});
	
	//Items drag effect
	$('.cispro_images_row img').on('dragstart', function(event) { event.preventDefault(); });
	$('.cispro_row_item_overlay').on('dragstart', function(event) { event.preventDefault(); });
	
	//Globals
	var cispro_posXdragStart = 0,
		cispro_currentMouseX = -1,
		cispro_swipe_offset = 15,
		cispro_move_interval='';
	
	$('.cispro_images_row').mousemove(function(event) {
		cispro_currentMouseX = event.pageX;
    });
	
	$('.cispro_images_row').mousedown(function(e) {
		
		//disable drag for overlay
		 if($(e.target).hasClass('cispro_row_item_overlay_txt') || $(e.target).hasClass('creative_btn') || 
			$(e.target).hasClass('cispro_row_item_overlay') || $(e.target).hasClass('creative_icon-white')) {
			 return;
		 }
		
		cispro_posXdragStart = cispro_currentMouseX;
		var $cispro_wrapper = $(this).find('.cispro_images_holder');
		cispro_move_interval = setInterval(function() {cispro_makeDrag($cispro_wrapper);},10);
	});
	
	function cispro_makeDrag($cispro_wrapper) {
		if(cispro_posXdragStart - cispro_currentMouseX >= cispro_swipe_offset) {
			cispro_move_images_holder_left($cispro_wrapper);
			cispro_clear_interval();
		}
		else if(cispro_currentMouseX - cispro_posXdragStart >= cispro_swipe_offset) {
			cispro_move_images_holder_right($cispro_wrapper);
			cispro_clear_interval();
		}
	};
	
	$('.cispro_images_row').mouseup(function() {
		cispro_clear_interval();
	});
	$('.cispro_images_row').mouseleave(function() {
		cispro_clear_interval();
	});
	
	//clear interval
	function cispro_clear_interval() {
		clearInterval(cispro_move_interval);
	};
	
	//hover animation
	//calculate overlay height
	function cispro_calculate_itms_height() {
		$(".cispro_row_item").each(function() {
			var $cispro_overlay = $(this).find('.cispro_row_item_overlay');
			$cispro_overlay.css({'visibility' : 'hidden','display' : 'block'});
			//var h = $cispro_overlay.height();
			//$cispro_overlay.css({'visibility' : 'visible','display' : 'block','height' : '0'}).attr('h',h);
		});
	};
	
	$(".cispro_row_item img").load(function() {
		var $this = $(this);
		$this.attr('cispro_loaded','loaded');
		var $cispro_overlay = $(this).next('.cispro_row_item_overlay');
		$cispro_overlay.css({'visibility' : 'hidden','display' : 'block'});
		var h = $cispro_overlay.height();
		$cispro_overlay.css({'visibility' : 'visible','display' : 'block','height' : '0'}).attr('h',h);
		$cispro_overlay.attr('cispro_animation','enabled');
		
		$this.addClass('cispro_loaded');
		setTimeout(function() {
			cispro_make_proccess($this);
		},400);
	});
	
	function cispro_make_proccess($el) {
		var item_width = $el.width();
		$el.parents('.cispro_row_item').find('.cispro_row_item_loader').animate({
			width: item_width
		},400,'swing',function() {
			$el.parents('.cispro_row_item').find('.cispro_row_item_loader').fadeOut(200,function() {
				$el.parents('.cispro_row_item_inner').hide().removeClass('cispro_row_hidden_element').fadeIn(200);
			});
		});
	};
	
	function cispro_getRandomArbitary (min, max) {
	    return Math.random() * (max - min) + min;
	};
	
	function cispro_calculate_loaders_width() {
		$('.cispro_images_holder').each(function() {
			var $wrapper = $(this);
			var wrapper_width = $wrapper.parents('.cispro_images_row').width();
			var items_height = $wrapper.find('.cispro_row_item_loader').height();
			
			var loader_prepared_width = items_height * 1.5;
			var loader_ratio_sign = Math.random() < 0.5 ? 1 : -1;
			$wrapper.find('.cispro_row_item_loader').each(function() {
				var loader_width_calculated = loader_prepared_width + loader_ratio_sign * cispro_getRandomArbitary(0,20);
				$(this).width(loader_width_calculated);
				loader_ratio_sign = loader_ratio_sign == 1 ? -1 : 1;
			});
		});
	};
	cispro_calculate_loaders_width();
	
	//overlay functions
	$('.cispro_main_wrapper').each(function() {
		var $this = $(this);
		var cispro_overlay_type = parseInt($(this).attr("cispro_overlay_type"));
		if(cispro_overlay_type == 0) { // slide-up on hover

			$this.find(".cispro_row_item").hover(function() {
				var animation_enabled = $(this).find('.cispro_row_item_overlay').attr('cispro_animation');
				if(animation_enabled != 'enabled')
					return;
				
				if(!($(this).parents('.cispro_images_holder').hasClass('cispro_scrolling'))) {
					var $cispro_overlay = $(this).find('.cispro_row_item_overlay');
					var overlay_height = parseInt($cispro_overlay.attr('h'));
					$cispro_overlay.stop().animate({
						height: overlay_height
					},300,'swing');
				}
			},function() {
				var animation_enabled = $(this).find('.cispro_row_item_overlay').attr('cispro_animation');
				if(animation_enabled != 'enabled')
					return;
				
				var $cispro_overlay = $(this).find('.cispro_row_item_overlay');
				$cispro_overlay.stop().animate({
					height: 0
				},300,'swing');
			});
		}
		else if(cispro_overlay_type == 1) { // keep opened
			$this.find(".cispro_row_item_overlay").addClass("cispro_height_auto");
		}		
		else if(cispro_overlay_type == 2) { // special animation
			// TODO!!!
		}
	});
	
})
})(creativeJ);