<?php
/**
 * Joomla! component creativeimagesliderpro
 *
 * @version $Id: default.php 2012-04-05 14:30:25 svn $
 * @author Creative-Solutions.net
 * @package Creative Image Slider
 * @subpackage com_creativeimagesliderpro
 * @license GNU/GPL v2.0
 *
 */

// no direct access
defined('_JEXEC') or die('Restircted access');;

class CreativeimagesliderproHelper
{
	//function to add scripts/styles
	private function add_scripts() {
		//add scripts, styles
		$document = JFactory::getDocument();
		
		$version = '1.0.0';
		
		$cssFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/css/main.css?version='.$version;
		$document->addStyleSheet($cssFile, 'text/css', null, array());
		
		$cssFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/css/creative_buttons.css';
		$document->addStyleSheet($cssFile, 'text/css', null, array());
		
		$cssFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/css/creativecss-ui.css';
		$document->addStyleSheet($cssFile, 'text/css', null, array());
		
		$jsFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/js/creativelib.js';
		$document->addScript($jsFile);
		
		$jsFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/js/creativelib-ui.js';
		$document->addScript($jsFile);
		
		$jsFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/js/mousewheel.js';
		$document->addScript($jsFile);
		
		$jsFile = JURI::base(true).'/components/com_creativeimagesliderpro/assets/js/creativeimagesliderpro.js?version='.$version;
		$document->addScript($jsFile);
	}
	
	private function cispro_hex2rgb($hex) {
		$hex = str_replace("#", "", $hex);
	
		if(strlen($hex) == 3) {
			$r = hexdec(substr($hex,0,1).substr($hex,0,1));
			$g = hexdec(substr($hex,1,1).substr($hex,1,1));
			$b = hexdec(substr($hex,2,1).substr($hex,2,1));
		} else {
			$r = hexdec(substr($hex,0,2));
			$g = hexdec(substr($hex,2,2));
			$b = hexdec(substr($hex,4,2));
		}
		$rgb = array($r, $g, $b);
		return implode(",", $rgb); // returns the rgb values separated by commas
		//return $rgb; // returns an array with the rgb values
	}
	
	private function get_data() {
		$db = JFactory::getDBO();
		
		$query = 'SELECT '.
				'sp.id slider_id, ' .
				'sp.id_template, ' .
				'sp.width, ' .
				'sp.height, ' .
				'sp.itemsoffset, ' .
				'sp.margintop, ' .
				'sp.marginbottom, ' .
				'sp.paddingtop, ' .
				'sp.paddingbottom, ' .
				'sp.showarrows, ' .
				'sp.bgcolor, ' .
				'sp.showreadmore, ' .
				'sp.readmoretext, ' .
				'sp.readmorestyle, ' .
				'sp.readmoresize, ' .
				'sp.readmoreicon, ' .
				'sp.readmorealign, ' .
				'sp.readmoremargin, ' .
				'sp.captionalign, ' .
				'sp.captionmargin, ' .
				'sp.overlaycolor, ' .
				'sp.overlayopacity, ' .
				'sp.textcolor, ' .
				'sp.overlayfontsize, ' .
				'sp.textshadowcolor, ' .
				'sp.textshadowsize, ' .
				'sp.arrow_template, ' .
				'sp.arrow_width, ' .
				'sp.arrow_left_offset, ' .
				'sp.arrow_center_offset, ' .
				'sp.arrow_passive_opacity, ' .
				'sp.move_step, ' .
				'sp.move_time, ' .
				'sp.move_ease, ' .
				'sp.autoplay, ' .
				'sp.autoplay_start_timeout, ' .
				'sp.autoplay_hover_timeout, ' .
				'sp.autoplay_step_timeout, ' .
				'sp.autoplay_evenly_speed, ' .

				'sp.overlayanimationtype, ' .
				'sp.popup_max_size, ' .
				'sp.popup_item_min_width, ' .
				'sp.popup_use_back_img, ' .
				'sp.popup_arrow_passive_opacity, ' .
				'sp.popup_arrow_left_offset, ' .
				'sp.popup_arrow_min_height, ' .
				'sp.popup_arrow_max_height, ' .
				'sp.popup_showarrows, ' .
				'sp.popup_image_order_opacity, ' .
				'sp.popup_image_order_top_offset, ' .
				'sp.popup_show_orderdata, ' .
				'sp.popup_icons_opacity, ' .
				'sp.popup_show_icons, ' .
				'sp.popup_autoplay_default, ' .
				'sp.popup_closeonend, ' .
				'sp.popup_autoplay_time, ' .
				'sp.popup_open_event, ' .

				'sa.id img_id, ' .
				'sa.name img_name, ' .
				'sa.img_name img_path, ' .
				'sa.img_url img_url_path ,' .
				'sa.caption ,' .
				'sa.showarrows item_showarrows, ' .
				'sa.showreadmore item_showreadmore, ' .
				'sa.readmoretext item_readmoretext, ' .
				'sa.readmorestyle item_readmorestyle, ' .
				'sa.readmoresize item_readmoresize, ' .
				'sa.readmoreicon item_readmoreicon, ' .
				'sa.readmorealign item_readmorealign, ' .
				'sa.readmoremargin item_readmoremargin, ' .
				'sa.captionalign item_captionalign, ' .
				'sa.captionmargin item_captionmargin, ' .
				'sa.overlaycolor item_overlaycolor, ' .
				'sa.overlayopacity item_overlayopacity, ' .
				'sa.textcolor item_textcolor, ' .
				'sa.overlayfontsize item_overlayfontsize, ' .
				'sa.textshadowcolor item_textshadowcolor, ' .
				'sa.textshadowsize item_textshadowsize, ' .
				'sa.overlayusedefault, ' .
				'sa.buttonusedefault, ' .
				'sa.redirect_url, ' .
				'sa.redirect_itemid, ' .
				'sa.redirect_target, ' .

				'sa.popup_img_name, ' .
				'sa.popup_img_url, ' .
				'sa.popup_open_event item_popup_open_event ' .

				'FROM '.
				'`#__cispro_sliders` sp '.
				'JOIN '.
				'`#__cispro_images` sa ON sa.id_slider = sp.id '.
				'AND sa.published = \'1\' '.
				'LEFT JOIN '.
				'`#__cispro_templates` st ON st.id = sp.id_template '.
				'WHERE sp.published = \'1\' '.
				'AND sp.id = '.$this->slider_id.' '.
				'ORDER BY sp.ordering,sp.id,sa.ordering,sa.id';
		$db->setQuery( $query );
		$this->_data = $db->loadObjectList();
	}
	
	public function render_html()
	{
		//add scripts
		if($this->type != 'plugin')
			$this->add_scripts();
		
		//get data
		$this->get_data();
		
		$module_id = $this->module_id;
		
		$cispro_options = array();
		
		for ($i=0, $n=count( $this->_data ); $i < $n; $i++) {
			$cispro_options[$this->_data[$i]->slider_id][] = $this->_data[$i];
		}
		
		if(sizeof($cispro_options) > 0) {
			reset($cispro_options);
			$first_key = key($cispro_options);
		
			$cispro_options_value = $cispro_options[$first_key][0];
		
			$cispro_width = $cispro_options_value->width;
			$cispro_item_height = (int) $cispro_options_value->height;
			$cispro_id_template = (int) $cispro_options_value->id_template;
			$cispro_margintop = (int) $cispro_options_value->margintop;
			$cispro_marginbottom = (int) $cispro_options_value->marginbottom;
			$cispro_paddingtop = (int) $cispro_options_value->paddingtop;
			$cispro_paddingbottom = (int) $cispro_options_value->paddingbottom;
			$cispro_itemsoffset = (int) $cispro_options_value->itemsoffset;
			$cispro_showarrows = (int) $cispro_options_value->showarrows;
			$cispro_bgcolor =  $cispro_options_value->bgcolor;
			$cispro_showreadmore = (int) $cispro_options_value->showreadmore;
			$cispro_readmoretext =  $cispro_options_value->readmoretext;
			$cispro_readmorestyle =  $cispro_options_value->readmorestyle;
			$cispro_readmoresize =  $cispro_options_value->readmoresize;
			$cispro_readmoreicon =  $cispro_options_value->readmoreicon;
			$cispro_readmorealign =  (int) $cispro_options_value->readmorealign;
			$cispro_readmoremargin =  $cispro_options_value->readmoremargin;
			$cispro_overlaycolor =  $cispro_options_value->overlaycolor;
			$cispro_overlayopacity = (int) $cispro_options_value->overlayopacity;
			$cispro_textcolor = $cispro_options_value->textcolor;
			$cispro_overlayfontsize = (int) $cispro_options_value->overlayfontsize;
			$cispro_textshadowcolor =  $cispro_options_value->textshadowcolor;
			$cispro_textshadowsize = (int) $cispro_options_value->textshadowsize;
			$cispro_captionalign = (int) $cispro_options_value->captionalign;
			$cispro_captionmargin = $cispro_options_value->captionmargin;
			
			$cispro_arrow_template = $cispro_options_value->arrow_template;
			$cispro_arrow_width = $cispro_options_value->arrow_width;
			$cispro_arrow_left_offset = $cispro_options_value->arrow_left_offset;
			$cispro_arrow_center_offset = $cispro_options_value->arrow_center_offset;
			$cispro_arrow_passive_opacity = $cispro_options_value->arrow_passive_opacity;
			
			$cispro_move_step = $cispro_options_value->move_step;
			$cispro_move_time = $cispro_options_value->move_time;
			$cispro_move_ease = $cispro_options_value->move_ease;
			$cispro_autoplay = $cispro_options_value->autoplay;
			$cispro_autoplay_start_timeout = $cispro_options_value->autoplay_start_timeout;
			$cispro_autoplay_hover_timeout = $cispro_options_value->autoplay_hover_timeout;
			$cispro_autoplay_step_timeout = $cispro_options_value->autoplay_step_timeout;
			$cispro_autoplay_evenly_speed = $cispro_options_value->autoplay_evenly_speed;

			$cispro_overlayanimationtype = (int) $cispro_options_value->overlayanimationtype;

			// this section is used for js in cispro_popup_data element
			$cispro_popup_max_size = (int) $cispro_options_value->popup_max_size;
			$cispro_popup_item_min_width = (int) $cispro_options_value->popup_item_min_width;
			$cispro_popup_use_back_img = (int) $cispro_options_value->popup_use_back_img;
			$cispro_popup_arrow_passive_opacity = (int) $cispro_options_value->popup_arrow_passive_opacity;//3
			$cispro_popup_arrow_left_offset = (int) $cispro_options_value->popup_arrow_left_offset;
			$cispro_popup_arrow_min_height= (int) $cispro_options_value->popup_arrow_min_height;
			$cispro_popup_arrow_max_height = (int) $cispro_options_value->popup_arrow_max_height;
			$cispro_popup_showarrows = (int) $cispro_options_value->popup_showarrows;//7
			$cispro_popup_image_order_opacity = (int) $cispro_options_value->popup_image_order_opacity;
			$cispro_popup_image_order_top_offset = (int) $cispro_options_value->popup_image_order_top_offset;
			$cispro_popup_show_orderdata= (int) $cispro_options_value->popup_show_orderdata;
			$cispro_popup_icons_opacity = (int) $cispro_options_value->popup_icons_opacity;
			$cispro_popup_show_icons = (int) $cispro_options_value->popup_show_icons;//12
			$cispro_popup_autoplay_default = (int) $cispro_options_value->popup_autoplay_default;
			$cispro_popup_closeonend = (int) $cispro_options_value->popup_closeonend;
			$cispro_popup_autoplay_time = (int) $cispro_options_value->popup_autoplay_time;
			// end section

			$cispro_popup_open_event = (int) $cispro_options_value->popup_open_event;

			$cache_dir = __DIR__ . '/../../../cache/com_creativeimagesliderpro/';
			$cached_img_dir = JURI::base(true) . '/cache/com_creativeimagesliderpro/';
			$uploaded_img_dir = JURI::base(true) . '/';
		
			ob_start();
			
			$id_slider = $this->slider_id;
			
			//start render html
			$cispro_class_suffix = $this->class_suffix == '' ? '' : ' '  . $this->class_suffix;
			echo '<div id="cispro_slider_'.$id_slider.'" cispro_overlay_type="'.$cispro_overlayanimationtype.'" roll="'.$module_id.'_'.$id_slider.'" cispro_slider_id="'.$id_slider.'" class="cispro_main_wrapper'.$cispro_class_suffix.' cispro_wrapper_'.$module_id.'_'.$id_slider.'" cispro_base="'.JURI::base(true).'">';
			echo '<div class="cispro_images_row">';
			
			//buttons
			$img_src1 = JURI::base(true) .'/components/com_creativeimagesliderpro/assets/images/arrows/cispro_button_left'.$cispro_arrow_template.'.png';
			$img_src2 = JURI::base(true) .'/components/com_creativeimagesliderpro/assets/images/arrows/cispro_button_right'.$cispro_arrow_template.'.png';
			echo '<img class="cispro_button_left" src="'.$img_src1.'" />';
			echo '<img class="cispro_button_right" src="'.$img_src2.'" />';
			echo '<div class="cispro_arrow_data" style="display: none !important;">'.$cispro_arrow_width.','.$cispro_arrow_left_offset.','.$cispro_arrow_center_offset.','.$cispro_arrow_passive_opacity.','.$cispro_showarrows.'</div>';
			echo '<div class="cispro_moving_data" style="display: none !important;">'.$cispro_move_step.','.$cispro_move_time.','.$cispro_move_ease.','.$cispro_autoplay.','.$cispro_autoplay_start_timeout.','.$cispro_autoplay_step_timeout.','.$cispro_autoplay_evenly_speed.','.$cispro_autoplay_hover_timeout.'</div>';

			echo '<div class="cispro_popup_data" style="display: none !important;">'.$cispro_popup_max_size.','.$cispro_popup_item_min_width.','.$cispro_popup_use_back_img.','.$cispro_popup_arrow_passive_opacity.','.$cispro_popup_arrow_left_offset.','.$cispro_popup_arrow_min_height.','.$cispro_popup_arrow_max_height.','.$cispro_popup_showarrows.','.$cispro_popup_image_order_opacity.','.$cispro_popup_image_order_top_offset.','.$cispro_popup_show_orderdata.','.$cispro_popup_icons_opacity.','.$cispro_popup_show_icons.','.$cispro_popup_autoplay_default.','.$cispro_popup_closeonend.','.$cispro_popup_autoplay_time.'</div>';

			echo '<div class="cispro_images_holder">';
		
			$items_css = '';
			$loader_color_class = 'cispro_row_item_loader_color1';
			foreach( $cispro_options[$first_key] as $cispro_index => $image_info) {
				//get image
				$img_path = $image_info->img_path != '' ? $image_info->img_path : $image_info->img_url_path;
				if($image_info->img_path != '') {
					//check to see if cached file exists
					$img_parts = explode('/',$image_info->img_path);
					$filename = $img_parts[sizeof($img_parts) - 1];
					preg_match('/^(.*)\.([a-z]{3,4}$)/i',$filename,$matches);
					$img_path_cache = $matches[1] . '-tmb-h' . $cispro_item_height . '.' . $matches[2];
					$img_fullpath_cache = $cache_dir . $img_path_cache;
					if(file_exists($img_fullpath_cache)) {
						$img_path = $cached_img_dir . $img_path_cache;
					}
					else {
						$img_path = $uploaded_img_dir . $image_info->img_path;
					}
				}

				//get popup image
				$popup_img_src = '';
				if( ($image_info->item_popup_open_event != 2 && $image_info->item_popup_open_event != 3)  && !($image_info->item_popup_open_event == 4 && ($cispro_popup_open_event == 2 && $cispro_popup_open_event == 3)) ) {//check if popup enabled
					//if we have uploaded popup image
					if($image_info->popup_img_name != '') {
						$popup_img_src = $uploaded_img_dir . $image_info->popup_img_name;
					}
					elseif($image_info->popup_img_url != '') {
						$popup_img_src = $image_info->popup_img_url;
					}
					else {
						$popup_img_src = ($image_info->img_path != '') ? $uploaded_img_dir . $image_info->img_path : $image_info->img_url_path;
					}
				}
				
					
				echo '<div class="cispro_row_item" id="cispro_item_'.$image_info->img_id.'" cispro_popup_link="'.$popup_img_src.'" item_id="'.$image_info->img_id.'">';

				// set caption
				echo '<div class="cispro_popup_caption" style="display: none !important;">'.$image_info->caption.'</div>';
				$loader_color_class = $loader_color_class == 'cispro_row_item_loader_color1' ? 'cispro_row_item_loader_color2' : 'cispro_row_item_loader_color1';
				echo '<div class="cispro_row_item_loader '.$loader_color_class.'" style="height: '.$cispro_item_height.'px !important;"></div>';
				echo '<div class="cispro_row_item_inner cispro_row_hidden_element">';
				//image
				echo '<img src="'.$img_path.'" style="height: '.$cispro_item_height.'px !important;"  />';

				//get click url
				$click_url = $image_info->redirect_url != '' ? JRoute::_($image_info->redirect_url, false) : JRoute::_('index.php?Itemid='.$image_info->redirect_itemid);

				//is button visible
				$cispro_button_visible = (($image_info->buttonusedefault == 0 && $cispro_showreadmore == 1) || ($image_info->buttonusedefault == 1 && $image_info->item_showreadmore == 1)) ? 1 : 0;
		
				// get overlay event type
				$cispro_overlay_event = $image_info->item_popup_open_event == 4 ? $cispro_popup_open_event : $image_info->item_popup_open_event;
				//overlay
				echo '<div class="cispro_row_item_overlay" cispro_popup_event="'.$cispro_overlay_event.'" cispro_click_url="'.$click_url.'" cispro_click_target="'.$image_info->redirect_target.'" cispro_button_visible="'.$cispro_button_visible.'">';
				//name
				echo '<div class="cispro_row_item_overlay_txt">'.$image_info->img_name.'</div>';
					
				//button
				if(($image_info->buttonusedefault == 0 && $cispro_showreadmore == 1) || ($image_info->buttonusedefault == 1 && $image_info->item_showreadmore == 1)) {
					
					//click target
					$click_target = $image_info->redirect_target == 0 ? '' : ' target="_blank"';
		
					//read more text
					$item_readmoretext = $image_info->overlayusedefault == 0 ? $cispro_readmoretext : $image_info->item_readmoretext;
		
					//button styles
					if($image_info->buttonusedefault == 0) {
						$button_style = 'creative_btn-' . $cispro_readmorestyle;
						$button_size = 'creative_btn-' . $cispro_readmoresize;
						$button_icon_color = $cispro_readmorestyle == 'gray' ? 'white' : 'white';
						$button_icon_html = $cispro_readmoreicon == 'none' ? '' : '<i class="creative_icon-'.$button_icon_color.' creative_icon-'.$cispro_readmoreicon.'"></i> ';
					}
					else {
						$button_style = 'creative_btn-' . $image_info->item_readmorestyle;
						$button_size = 'creative_btn-' . $image_info->item_readmoresize;
						$button_icon_color = $image_info->item_readmorestyle == 'gray' ? 'white' : 'white';
						$button_icon_html = $image_info->item_readmoreicon == 'none' ? '' : '<i class="creative_icon-'.$button_icon_color.' creative_icon-'.$image_info->item_readmoreicon.'"></i> ';
					}
					echo '<a href="'.$click_url.'" class="creative_btn '.$button_style.' '.$button_size.'"'.$click_target.'>'.$button_icon_html . $item_readmoretext.'</a>';
		
					//generate css
					if($image_info->overlayusedefault == 1) {
						$item_overlaycolor_rgb = $this->cispro_hex2rgb($image_info->item_overlaycolor);
						$item_overlayopacity = $image_info->item_overlayopacity / 100;
						$item_overlaycolor_rgba = 'rgba('.$item_overlaycolor_rgb.','.$item_overlayopacity.')';
							
						//get txt text shadow;
						if($image_info->item_textshadowsize == 0)
							$item_textshadow_rule = 'text-shadow: none;';
						elseif($image_info->item_textshadowsize == 1)
						$item_textshadow_rule = 'text-shadow: -1px 2px 0px '.$image_info->item_textshadowcolor.';';
						elseif($image_info->item_textshadowsize == 2)
						$item_textshadow_rule = 'text-shadow: -1px 2px 2px '.$image_info->item_textshadowcolor.';';
						elseif($image_info->item_textshadowsize == 3)
						$item_textshadow_rule = 'text-shadow: -1px 2px 4px '.$image_info->item_textshadowcolor.';';
							
						//text align
						$cispro_ta = $image_info->item_readmorealign == 2 ? 'center' : 'left';
						$cispro_text_align = $image_info->item_captionalign == 0 ? 'left' : ($image_info->item_captionalign == 1 ? 'right' : 'center');
							
						$items_css .= '#cispro_slider_'.$id_slider.' #cispro_item_'.$image_info->img_id.' .cispro_row_item_overlay {';
						$items_css .= 'background-color: '.$image_info->item_overlaycolor.';';
						$items_css .= 'background-color: '.$item_overlaycolor_rgba.';';
						$items_css .= 'text-align: '.$cispro_ta.';';
						$items_css .= '}';
						$items_css .= '#cispro_slider_'.$id_slider.' #cispro_item_'.$image_info->img_id.' .cispro_row_item_overlay_txt {';
						$items_css .= $item_textshadow_rule;
						$items_css .= 'font-size: '.$image_info->item_overlayfontsize.'px;';
						$items_css .= 'color: '.$image_info->item_textcolor.';';
						$items_css .= 'margin: '.$image_info->item_captionmargin.';';
						$items_css .= 'text-align: '.$cispro_text_align.';';
						$items_css .= '}';
					}
					if($image_info->overlayusedefault == 1) {
						$cispro_float = $image_info->item_readmorealign == 0 ? 'left' : ($image_info->item_readmorealign == 1 ? 'right' : 'none');
							
						$items_css .= '#cispro_slider_'.$id_slider.' #cispro_item_'.$image_info->img_id.' .creative_btn {';
						$items_css .= 'margin: '.$image_info->item_readmoremargin.';';
						$items_css .= 'float: '.$cispro_float.';';
						$items_css .= '}';
					}
				}
				echo '</div>';
				echo '</div>';
				echo '</div>';
			}
				
			echo '</div>';
			echo '</div>';
			echo '</div>';
			
			//print css
			$cispro_overlaycolor_rgb = $this->cispro_hex2rgb($cispro_overlaycolor);
			$cispro_overlayopacity = $cispro_overlayopacity / 100;
			$cispro_overlaycolor_rgba = 'rgba('.$cispro_overlaycolor_rgb.','.$cispro_overlayopacity.')';
			
			//get txt text shadow;
			if($cispro_textshadowsize == 0)
				$cispro_textshadow_rule = 'text-shadow: none;';
			elseif($cispro_textshadowsize == 1)
			$cispro_textshadow_rule = 'text-shadow: -1px 2px 0px '.$cispro_textshadowcolor.';';
			elseif($cispro_textshadowsize == 2)
			$cispro_textshadow_rule = 'text-shadow: -1px 2px 2px '.$cispro_textshadowcolor.';';
			elseif($cispro_textshadowsize == 3)
			$cispro_textshadow_rule = 'text-shadow: -1px 2px 4px '.$cispro_textshadowcolor.';';
			
			$cispro_css = '';
			$cispro_css .= '#cispro_slider_'.$id_slider.'.cispro_main_wrapper {';
			$cispro_css .= 'width: '.$cispro_width.'!important;';
			$cispro_css .= 'margin: '.$cispro_margintop.'px auto '.$cispro_marginbottom.'px;';
			$cispro_css .= 'padding: '.$cispro_paddingtop.'px 0px '.$cispro_paddingbottom.'px 0px;';
			$cispro_css .= 'background-color: '.$cispro_bgcolor.';';
			$cispro_css .= '}';
			$cispro_css .= '#cispro_slider_'.$id_slider.' .cispro_row_item_overlay {';
			$cispro_css .= 'background-color: '.$cispro_overlaycolor.';';
			$cispro_css .= 'background-color: '.$cispro_overlaycolor_rgba.';';
			$cispro_ta = $cispro_readmorealign == 2 ? 'center' : 'left';
			$cispro_css .= 'text-align: '.$cispro_ta.';';
			$cispro_css .= '}';
			$cispro_css .= '#cispro_slider_'.$id_slider.' .cispro_row_item {';
			$cispro_css .= 'margin-right: '.$cispro_itemsoffset.'px;';
			$cispro_css .= '}';
			$cispro_css .= '#cispro_slider_'.$id_slider.' .cispro_row_item_overlay_txt {';
			$cispro_css .= $cispro_textshadow_rule;
			$cispro_css .= 'font-size: '.$cispro_overlayfontsize.'px;';
			$cispro_css .= 'color: '.$cispro_textcolor.';';
			$cispro_css .= 'margin: '.$cispro_captionmargin.';';
			$cispro_text_align = $cispro_captionalign == 0 ? 'left' : ($cispro_captionalign == 1 ? 'right' : 'center');
			$cispro_css .= 'text-align: '.$cispro_text_align.';';
			$cispro_css .= '}';
			$cispro_css .= '#cispro_slider_'.$id_slider.' .creative_btn {';
			$cispro_css .= 'margin: '.$cispro_readmoremargin.';';
			$cispro_float = $cispro_readmorealign == 0 ? 'left' : ($cispro_readmorealign == 1 ? 'right' : 'none');
			$cispro_css .= 'float: '.$cispro_float.';';
			$cispro_css .= '}';
			
			echo '<style>'.$cispro_css.$items_css.'</style>';
		}
		else
			echo 'Creative Image Slider: There is nothing to show!';
		
		return $render_html1 = ob_get_clean();
	}
}